// CallBackDlg.cpp : implementation file
//

#include "stdafx.h"
#include "CallBack.h"
#include "CallBackDlg.h"

#ifdef _WIN64
#include "okapi64.h"
#else
#include "okapi32.h"
#endif

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

char		string[20];
float		ratio=25;
long		num;
DWORD		times;

HWND hWnd;
BOOL  symbol=0;
BOOL  texttimes=0;
LPBITMAPINFOHEADER	lpbi;
LPBYTE				lpdib;
BLOCKINFO	blk;
BOOL	bSave=0;
BOOL CALLBACK BeginCapture(HANDLE hBoard);
BOOL CALLBACK Process(HANDLE hBoard, MLONG no);
BOOL CALLBACK EndCapture(HANDLE hBoard);
long exSetBitmapHeader(LPBITMAPINFOHEADER lpbi,short width,short height, short bits, short form);
long exGetTargetSize(HANDLE hBoard, TARGET tgt, short *width, short *height);
/////////////////////////////////////////////////////////////////////////////
// CCallBackDlg dialog

CCallBackDlg::CCallBackDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCallBackDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCallBackDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDI_OKDEMO);
}

void CCallBackDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCallBackDlg)
	DDX_Control(pDX, IDC_IMAGE, m_image);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCallBackDlg, CDialog)
	//{{AFX_MSG_MAP(CCallBackDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_CHECK2, OnCheck2)
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	ON_BN_CLICKED(IDC_SAVE, OnSave)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCallBackDlg message handlers

BOOL CCallBackDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	//***************************************************************//
	//************ open card and initialize the application *********//
	MLONG	lIndex=-1;
	RECT	rect;

	hBoard=okOpenBoard(&lIndex); 

//	okSetCaptureParam(hBoard,CAPTURE_CLIPMODE,0);
//	okSetCaptureParam(hBoard,CAPTURE_BUFRGBFORMAT,FORM_RGB888);
	rect.right=-1;
	okSetTargetRect(hBoard,BUFFER,&rect);
	lpbi=(LPBITMAPINFOHEADER)GlobalAlloc(GPTR,rect.right*rect.bottom*4+5120);
	if (lpbi == 0)
	{
		MessageBox("ڴʧܣ", NULL, MB_OK);
	}
	lpdib=(LPBYTE)lpbi+5120;
	hWnd=AfxGetApp()->m_pMainWnd->m_hWnd;

	//***************************************************************//
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCallBackDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else if( (hBoard!=0) && (lpbi!=0) )
	{
		CDC *cdc;
 		RECT rect;
 
 		cdc=m_image.GetDC();
 	
 		m_image.GetClientRect(&rect);
 		SetStretchBltMode(cdc->m_hDC,STRETCH_DELETESCANS);
 		StretchDIBits(cdc->m_hDC,
 			rect.left,rect.top,
 			rect.right,rect.bottom, 
 			0,0, //horzstart, vertstart, 
 			lpbi->biWidth,lpbi->biHeight,
 			lpdib,(LPBITMAPINFO)lpbi, 
 			DIB_RGB_COLORS,SRCCOPY);

 		ReleaseDC(cdc);

		CDialog::OnPaint();
	}
	else{}
	
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCallBackDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CCallBackDlg::OnStart() 
{
// 	RECT rect;
// 	SetRect(&rect,0,0,768,576);
// 	okSetTargetRect(hBoard,BUFFER,&rect);//Set Buffer Rect
		
	okSetSeqCallback(hBoard,BeginCapture,Process,EndCapture);
//	okCaptureSequence(hBoard,0,-1); //жϷʽ
	okCaptureTo(hBoard,BUFFER,0,-1);
	
}

void CCallBackDlg::OnStop() 
{
	okStopCapture(hBoard);	
}

void CCallBackDlg::OnClose() 
{
	okStopCapture(hBoard);	
	okCloseBoard(hBoard);
	hBoard = 0;

	CDialog::OnClose();
}

//****************CALLBACK FUNCTION***********************************


float exCalcCaptureRatio(long *num,DWORD *times)
{
	if( (*num>=12) || ((okGetTickCount()-(*times))>2000) ) 
	{
		*times=okGetTickCount()-(*times);
		ratio=((float)(*num)*1000/(*times));
		*num=0;
	}
	
	if(*num==0)
		(*times)=okGetTickCount();
	(*num)++;
	
	return ratio;
}

BOOL CALLBACK BeginCapture(HANDLE hBoard)
{	
	short		width,height;
	long		form;

	exGetTargetSize(hBoard, BUFFER, &width, &height);
	form=okSetCaptureParam(hBoard,CAPTURE_SCRRGBFORMAT,GETCURRPARAM); //-1
	exSetBitmapHeader(lpbi, width, height, HIWORD(form), LOWORD(form) );
	blk.lpBits=lpdib;
	blk.iBitCount=lpbi->biBitCount;
	blk.iHeight =-(short)lpbi->biHeight;
	blk.iWidth =(short)lpbi->biWidth;
	return 1;
}
    LOGFONT 	lfLogFont={ -20, 0, 0, 0, 400, 0, 0, 0, 0, 1, 2, 1, 26, "Arial"};
	SETTEXTMODE	textmode={0x0,0xffffff,2,0,0};  //
	

BOOL CALLBACK Process(HANDLE hBoard,MLONG no)
{	
	long	i;
	LPBYTE	lpbuf;
	short	height;
	MLONG	stride;
    SYSTEMTIME sys;
	char     date[20];
    lpbuf=(LPBYTE)okGetTargetInfo(hBoard,BUFFER,no,NULL,&height,&stride); 
	sprintf(string,"%5.2f",exCalcCaptureRatio(&num,&times));
	AfxGetApp()->m_pMainWnd->SetDlgItemText(IDC_RATIO,string);
	
    if (symbol==1) 
	{		
		for(i=0;i<=height*stride;i++)
		{
			*(lpbuf+i)=255-(*(lpbuf+i));
		}		
	}
	if (texttimes==1)
	{		 
		GetLocalTime( &sys ); 
		ZeroMemory(date,20);
 		sprintf(date,"%02d:%02d:%02d",sys.wHour,sys.wMinute,sys.wSecond); 
 
		RECT	rect= {25,25,0,0};

		textmode.wFrameNo=SHORT(no);
    	okSetTextTo(hBoard, BUFFER, &rect, &lfLogFont, &textmode,date, strlen(date)); 
	}	
	if (bSave==1)
	{
		GetLocalTime( &sys ); 
 		sprintf(date,"%02d%02d%02d.bmp",sys.wHour,sys.wMinute,sys.wSecond); 
		okSaveImageFile(hBoard, date, 0, BUFFER, no, 1);
		bSave=0;
	}
	okConvertRect(hBoard, (TARGET)&blk,  0, BUFFER, (short)no, 1);
	InvalidateRect(hWnd,NULL,FALSE);
 	UpdateWindow(hWnd);

	return 1;
}


BOOL CALLBACK EndCapture(HANDLE hBoard)
{
	okSetSeqCallback(hBoard,NULL,NULL,NULL);
//	okStopCapture(hBoard);

	return 1;
}
//********************************************************************

long exGetTargetSize(HANDLE hBoard, TARGET tgt, short *width, short *height)
{
	RECT	rect;
	long	form;


	if( (tgt==SCREEN ) ||(tgt==BUFFER) ) {
		rect.right=-1;
		okSetTargetRect(hBoard,tgt,&rect); //get current rect
		if(width)
			*width=(short)(rect.right-rect.left);
		if(height)
			*height=(short)(rect.bottom-rect.top);

		if(tgt==SCREEN ) {
			form=okSetCaptureParam(hBoard,CAPTURE_SCRRGBFORMAT,GETCURRPARAM); //-1
			//limit to video rect
			rect.right=-1; //max. captured rect
			okSetTargetRect(hBoard,VIDEO,&rect); //get video rect
			if(width)
				*width=(short)min(*width,rect.right-rect.left);
			if(height)
				*height=(short)min(*height,rect.bottom-rect.top);
		}
		else if(tgt==BUFFER) 
			form=okSetCaptureParam(hBoard,CAPTURE_BUFRGBFORMAT,GETCURRPARAM); //-1

	} else if(tgt>BUFFER) { //from blkinfo
		LPBLOCKINFO	lpblk;
		lpblk=(LPBLOCKINFO)tgt;

		if(width)
			*width=lpblk->iWidth;
		if(height)
			*height=abs(lpblk->iHeight);
		form=MAKELONG(lpblk->iFormType,lpblk->iBitCount);
	}


	return form;
}

long exSetBitmapHeader(LPBITMAPINFOHEADER lpbi,short width,short height, short bits, short form)
{
	long	wbytes;

	if(!lpbi)
		return FALSE;

	
	if(form==FORM_RGB555)
		bits=16;
	wbytes=((((width*bits)+31)&~31)>>3);//bmp need 4 byte align

	lpbi->biWidth=width;
	lpbi->biHeight=height;

	lpbi->biSize=sizeof(BITMAPINFOHEADER);
	lpbi->biPlanes=1;

	lpbi->biBitCount=bits;
	lpbi->biSizeImage=wbytes*height;


	lpbi->biClrUsed=0;
	//special format for 555,565 & 32 
	if(form==FORM_RGB555 || form==FORM_RGB565 || form==FORM_RGB8888 ) 
		lpbi->biCompression=BI_BITFIELDS;
	else
		lpbi->biCompression=0;
	if(lpbi->biCompression==BI_BITFIELDS ) {//
		DWORD	*lpmask;
		lpmask=(DWORD *)((LPSTR)lpbi+lpbi->biSize);

		if(form==FORM_RGB555) {
			lpmask[2]=0x001f; //blue
			lpmask[1]=0x03e0;
			lpmask[0]=0x7c00;
		}
		else if(form==FORM_RGB565) {
			lpmask[2]=0x001f; //blue
			lpmask[1]=0x07e0;
			lpmask[0]=0xf800;
		}
		else if(bits==32 ) {
			lpmask[2]=0x0000ff;
			lpmask[1]=0x00ff00;
			lpmask[0]=0xff0000;
		}
	}
	else if(bits<=14) { // 8,10,12
		int		i,ratio;
		RGBQUAD	*lpRGB=(RGBQUAD *)((LPSTR)lpbi+lpbi->biSize);

		lpbi->biClrUsed=(1<<bits);
		ratio=lpbi->biClrUsed/256;

		for(i=0; i<(short)lpbi->biClrUsed;i++) {
			lpRGB[i].rgbBlue=i/ratio;
			lpRGB[i].rgbGreen=i/ratio;
			lpRGB[i].rgbRed=i/ratio;
			lpRGB[i].rgbReserved=0;
		}
	
	} 
	lpbi->biClrImportant=lpbi->biClrUsed;

	return lpbi->biClrUsed;
}

BOOL CCallBackDlg::DestroyWindow() 
{
	GlobalFree(lpbi);
	
	return CDialog::DestroyWindow();
}

void CCallBackDlg::OnCheck1() 
{
	symbol=!symbol;
	
}
void CCallBackDlg::OnCheck2() 
{
	texttimes=!texttimes;
	
}

void CCallBackDlg::OnSave() 
{
	bSave=1;

	
}
