// CaptureActiveDlg.cpp : implementation file
//

#include "stdafx.h"
#include "CaptureActive.h"
#include "CaptureActiveDlg.h"

#include "okapi32.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCaptureActiveDlg dialog

CCaptureActiveDlg::CCaptureActiveDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCaptureActiveDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCaptureActiveDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDI_OKDEMO);
	bActive=FALSE;
}

void CCaptureActiveDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCaptureActiveDlg)
	DDX_Control(pDX, IDC_IMAGE, m_image);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCaptureActiveDlg, CDialog)
	//{{AFX_MSG_MAP(CCaptureActiveDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_WM_CLOSE()
	ON_WM_MOVE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCaptureActiveDlg message handlers

BOOL CCaptureActiveDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	//***************************************************************//
	//************ open card and initialize the application *********//
	long	lIndex=-1;
	hBoard=okOpenBoard(&lIndex);
	
	okSetCaptureParam(hBoard,CAPTURE_CLIPMODE,2);
	
	//***************************************************************//
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCaptureActiveDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCaptureActiveDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CCaptureActiveDlg::OnStart() 
{
	okSetToWndRect(hBoard,m_image);

	if(okCaptureTo(hBoard,SCREEN,0,0)>0)
		bActive=TRUE;
	
}

void CCaptureActiveDlg::OnStop() 
{
	okStopCapture(hBoard);
	bActive=FALSE;
}

void CCaptureActiveDlg::OnClose() 
{
	okCloseBoard(hBoard);
	CDialog::OnClose();

}

LRESULT CCaptureActiveDlg::DefWindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	if(message==WM_MOVING)
		if(bActive)
			okStopCapture(hBoard);
	return CDialog::DefWindowProc(message, wParam, lParam);
}

void CCaptureActiveDlg::OnMove(int x, int y) 
{
	CDialog::OnMove(x, y);
	
	if(bActive)
	{
		okSetToWndRect(hBoard,m_image);
		okCaptureTo(hBoard,SCREEN,0,0);
	}

}
