// CaptureImageDlg.cpp : implementation file
//

#include "stdafx.h"
#include "CaptureImage.h"
#include "CaptureImageDlg.h"

#ifdef _WIN64
#include "okapi64.h"
#else
#include "okapi32.h"
#endif

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

HWND hWnd;
LPBITMAPINFOHEADER	lpbi;
LPBYTE				lpdib;
BLOCKINFO	blk;
long        tnum;
char		string[20];
long		num;
DWORD		times;
float		ratio=25;
int         avi;
long exSetBitmapHeader(LPBITMAPINFOHEADER lpbi,short width,short height, short bits, short form);
long exGetTargetSize(HANDLE hBoard, TARGET tgt, short *width, short *height);
float exCalcCaptureRatio(long *num,DWORD *times);
BOOL CALLBACK BeginCapture(HANDLE hBoard);
BOOL CALLBACK Process(HANDLE hBoard, MLONG no);
BOOL CALLBACK EndCapture(HANDLE hBoard);

/////////////////////////////////////////////////////////////////////////////
// CCaptureImageDlg dialog

CCaptureImageDlg::CCaptureImageDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCaptureImageDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCaptureImageDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDI_OKDEMO);
}

void CCaptureImageDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCaptureImageDlg)
	DDX_Control(pDX, IDC_IMAGE, m_image);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCaptureImageDlg, CDialog)
	//{{AFX_MSG_MAP(CCaptureImageDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_STOP, OnStop)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCaptureImageDlg message handlers

BOOL CCaptureImageDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	//***************************************************************//
	//************ open card and initialize the application *********//
	MLONG	lIndex=-1;
	RECT	rect;

	hBoard=okOpenBoard(&lIndex);
//	okSetCaptureParam(hBoard,CAPTURE_CLIPMODE,0);
 //	okSetCaptureParam(hBoard,CAPTURE_BUFRGBFORMAT,FORM_GRAY8);
	rect.right=-1;
	okSetTargetRect(hBoard,BUFFER,&rect);
	lpbi=(LPBITMAPINFOHEADER)GlobalAlloc(GPTR,rect.right*rect.bottom*4+5120);
	lpdib=(LPBYTE)lpbi+5120;
	hWnd=AfxGetApp()->m_pMainWnd->m_hWnd;
	CheckRadioButton(IDC_RADIO1,IDC_RADIO2,IDC_RADIO1);
	
	//***************************************************************//
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCaptureImageDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDC *cdc;
		RECT rect;
		
		cdc=m_image.GetDC();
		
		m_image.GetClientRect(&rect);
		SetStretchBltMode(cdc->m_hDC,STRETCH_DELETESCANS);
		StretchDIBits(cdc->m_hDC,
			rect.left,rect.top,
			rect.right,rect.bottom, 
			0,0, //horzstart, vertstart, 
			lpbi->biWidth,lpbi->biHeight,
			lpdib,(LPBITMAPINFO)lpbi, 
			DIB_RGB_COLORS,SRCCOPY);
		
 		ReleaseDC(cdc);
		
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCaptureImageDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CCaptureImageDlg::OnStart() 
{
	tnum=0;
	if (IsDlgButtonChecked(IDC_RADIO1))
		avi=1;
	else if(IsDlgButtonChecked(IDC_RADIO2))
		avi=0;   
	okSetSeqCallback(hBoard,BeginCapture,Process,EndCapture);

	okCaptureTo(hBoard,BUFFER,0,-1);
// 	okCaptureSequence(hBoard,0,-1);

}

void CCaptureImageDlg::OnClose() 
{
	okStopCapture(hBoard);
	okCloseBoard(hBoard);
	GlobalFree(lpbi);
	
	CDialog::OnClose();
}

//****************CALLBACK FUNCTION***********************************
BOOL CALLBACK BeginCapture(HANDLE hBoard)
{
	short		width,height;
	long		form;
	
	exGetTargetSize(hBoard, BUFFER, &width, &height);
  	form=okSetCaptureParam(hBoard,CAPTURE_SCRRGBFORMAT,GETCURRPARAM); //-1
	exSetBitmapHeader(lpbi, width, height, HIWORD(form), LOWORD(form) );
	blk.lpBits=lpdib;
	blk.iBitCount=lpbi->biBitCount;
	blk.iHeight =-(short)lpbi->biHeight;
	blk.iWidth =(short)lpbi->biWidth;
	if (avi==1)
		okSaveImageFile(hBoard,"image.avi,mjpg,beg",0,BUFFER,0,1);
	
	return 1;
}

BOOL CALLBACK Process(HANDLE hBoard,MLONG no)
{	
	char  a[80];

	if (avi==1)
	{
		sprintf(a,"image.avi,mjpg,con");
		okSaveImageFile(hBoard,a,tnum,BUFFER,no,1);
	} 
	else
	{
		sprintf(a,"t%03d.jpg",tnum);
		okSaveImageFile(hBoard,a,0,BUFFER,no,1);
	}

	sprintf(string,"%5.2f",exCalcCaptureRatio(&num,&times));
	AfxGetApp()->m_pMainWnd->SetDlgItemText(IDC_STATIC,string);
	okConvertRect(hBoard,(TARGET)&blk,0,BUFFER,(short)no,1);
 	InvalidateRect(hWnd,NULL,FALSE);
 	UpdateWindow(hWnd);
	tnum++;

	return 1;
}

BOOL CALLBACK EndCapture(HANDLE hBoard)
{
	okSetSeqCallback(hBoard,NULL,NULL,NULL);
// 	okStopCapture(hBoard);
// 	if (avi==1)
// 		okSaveImageFile(hBoard,"image.avi,mjpg,end",0,BUFFER,0,1);

	return 1;
}
//********************************************************************
float exCalcCaptureRatio(long *num,DWORD *times)
{
	if( (*num>=12) || ((okGetTickCount()-(*times))>2000) ) 
	{
		*times=okGetTickCount()-(*times);
		ratio=((float)(*num)*1000/(*times));
		*num=0;
	}
	
	if(*num==0)
		(*times)=okGetTickCount();
	(*num)++;
	
	return ratio;
}

long exGetTargetSize(HANDLE hBoard, TARGET tgt, short *width, short *height)
{
	RECT	rect;
	long	form;


	if( (tgt==SCREEN ) ||(tgt==BUFFER) ) {
		rect.right=-1;
		okSetTargetRect(hBoard,tgt,&rect); //get current rect
		if(width)
			*width=(short)(rect.right-rect.left);
		if(height)
			*height=(short)(rect.bottom-rect.top);

		if(tgt==SCREEN ) {
			form=okSetCaptureParam(hBoard,CAPTURE_SCRRGBFORMAT,GETCURRPARAM); //-1
			//limit to video rect
			rect.right=-1; //max. captured rect
			okSetTargetRect(hBoard,VIDEO,&rect); //get video rect
			if(width)
				*width=(short)min(*width,rect.right-rect.left);
			if(height)
				*height=(short)min(*height,rect.bottom-rect.top);
		}
		else if(tgt==BUFFER) 
			form=okSetCaptureParam(hBoard,CAPTURE_BUFRGBFORMAT,GETCURRPARAM); //-1

	} else if(tgt>BUFFER) { //from blkinfo
		LPBLOCKINFO	lpblk;
		lpblk=(LPBLOCKINFO)tgt;

		if(width)
			*width=lpblk->iWidth;
		if(height)
			*height=abs(lpblk->iHeight);
		form=MAKELONG(lpblk->iFormType,lpblk->iBitCount);
	}


	return form;
}

long exSetBitmapHeader(LPBITMAPINFOHEADER lpbi,short width,short height, short bits, short form)
{
	long	wbytes;

	if(!lpbi)
		return FALSE;

	
	if(form==FORM_RGB555)
		bits=16;
	wbytes=((((width*bits)+31)&~31)>>3);//bmp need 4 byte align

	lpbi->biWidth=width;
	lpbi->biHeight=height;

	lpbi->biSize=sizeof(BITMAPINFOHEADER);
	lpbi->biPlanes=1;

	lpbi->biBitCount=bits;
	lpbi->biSizeImage=wbytes*height;


	lpbi->biClrUsed=0;
	//special format for 555,565 & 32 
	if(form==FORM_RGB555 || form==FORM_RGB565 || form==FORM_RGB8888 ) 
		lpbi->biCompression=BI_BITFIELDS;
	else
		lpbi->biCompression=0;
	if(lpbi->biCompression==BI_BITFIELDS ) {//
		DWORD	*lpmask;
		lpmask=(DWORD *)((LPSTR)lpbi+lpbi->biSize);

		if(form==FORM_RGB555) {
			lpmask[2]=0x001f; //blue
			lpmask[1]=0x03e0;
			lpmask[0]=0x7c00;
		}
		else if(form==FORM_RGB565) {
			lpmask[2]=0x001f; //blue
			lpmask[1]=0x07e0;
			lpmask[0]=0xf800;
		}
		else if(bits==32 ) {
			lpmask[2]=0x0000ff;
			lpmask[1]=0x00ff00;
			lpmask[0]=0xff0000;
		}
	}
	else if(bits<=14) { // 8,10,12
		int		i,ratio;
		RGBQUAD	*lpRGB=(RGBQUAD *)((LPSTR)lpbi+lpbi->biSize);

		lpbi->biClrUsed=(1<<bits);
		ratio=lpbi->biClrUsed/256;

		for(i=0; i<(short)lpbi->biClrUsed;i++) {
			lpRGB[i].rgbBlue=i/ratio;
			lpRGB[i].rgbGreen=i/ratio;
			lpRGB[i].rgbRed=i/ratio;
			lpRGB[i].rgbReserved=0;
		}
	
	} 
	lpbi->biClrImportant=lpbi->biClrUsed;

	return lpbi->biClrUsed;
}



void CCaptureImageDlg::OnStop() 
{
	okSetSeqCallback(hBoard,NULL,NULL,NULL);
	okStopCapture(hBoard);
	if(avi==1)
		okSaveImageFile(hBoard,"image.avi,mjpg,end",0,BUFFER,0,1);
}
