// GetSeqCaptureDlg.cpp : implementation file
//

#include "stdafx.h"
#include "GetSeqCapture.h"
#include "GetSeqCaptureDlg.h"

#ifdef _WIN64
#include "okapi64.h"
#else
#include "okapi32.h"
#endif

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

HWND hWnd;
BOOL bActive = FALSE;
HANDLE hThread;

SYSTEMTIME	sys;
char		date[10];


LPBITMAPINFOHEADER	lpbi;
LPBYTE				lpdib;
BLOCKINFO			blk;

LOGFONT 	lfLogFont={ -30, 0, 0, 0, 400, 0, 0, 0, 0, 1, 2, 1, 26, "Arial"};
SETTEXTMODE	textmode={0xffffff,0x0,2,0,0};  //

long		num;
DWORD		times;
float		ratio;

long exSetBitmapHeader(LPBITMAPINFOHEADER lpbi,short width,short height, short bits, short form);
float exCalcCaptureRatio(long *num,DWORD *times);
DWORD WINAPI ThreadFunc(LPVOID pParam);
DWORD WINAPI ThreadTerminate(LPVOID pParam);




/////////////////////////////////////////////////////////////////////////////
// CGetSeqCaptureDlg dialog

CGetSeqCaptureDlg::CGetSeqCaptureDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGetSeqCaptureDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGetSeqCaptureDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

}

void CGetSeqCaptureDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGetSeqCaptureDlg)
	DDX_Control(pDX, IDC_IMAGE, m_image);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CGetSeqCaptureDlg, CDialog)
	//{{AFX_MSG_MAP(CGetSeqCaptureDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CLOSE()
	ON_BN_CLICKED(ID_START, OnStart)
	ON_BN_CLICKED(ID_STOP, OnStop)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGetSeqCaptureDlg message handlers

BOOL CGetSeqCaptureDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	//***************************************************************//
	//************ open card and initialize the application *********//
	MLONG	lIndex=-1;
	
	hBoard=okOpenBoard(&lIndex);

	RECT	Rect;
	Rect.right=-1;
	okSetTargetRect(hBoard,BUFFER,&Rect);
	
	lpbi=(LPBITMAPINFOHEADER)GlobalAlloc(GPTR,
		(Rect.right - Rect.left)*(Rect.bottom- Rect.top)*4+5120);
 	lpdib=(LPBYTE)lpbi+5120;
 
	hWnd=AfxGetApp()->m_pMainWnd->m_hWnd;

	bActive = FALSE;	//ʼ״̬Ϊֹͣ
	((CButton*)GetDlgItem(IDC_CHECK3))-> SetCheck(1); 


	//***************************************************************//
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CGetSeqCaptureDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDC *cdc;
 		RECT rect;
 
 		cdc=m_image.GetDC();
 	
 		m_image.GetClientRect(&rect);
 		SetStretchBltMode(cdc->m_hDC,STRETCH_DELETESCANS);
 		StretchDIBits(cdc->m_hDC,
 			rect.left,rect.top,
 			rect.right,rect.bottom, 
 			0,0, //horzstart, vertstart, 
 			lpbi->biWidth,lpbi->biHeight,
 			lpdib,(LPBITMAPINFO)lpbi, 
 			DIB_RGB_COLORS,SRCCOPY);

 		ReleaseDC(cdc);

		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CGetSeqCaptureDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CGetSeqCaptureDlg::OnStart() 
{
	long		form;
	RECT		rect;
	int			no;
	DWORD		ThreadID;

	rect.right=-1;
	okSetTargetRect(hBoard,BUFFER,&rect);//get Buffer Rect

	form=okSetCaptureParam(hBoard,CAPTURE_SCRRGBFORMAT,GETCURRPARAM); //-1
	exSetBitmapHeader(lpbi, (short)rect.right, (short)rect.bottom, HIWORD(form), LOWORD(form) );
	blk.lpBits=lpdib;
	blk.iBitCount=lpbi->biBitCount;
	blk.iHeight =-(short)lpbi->biHeight;
	blk.iWidth =(short)lpbi->biWidth;

	int info= okSetCaptureParam(hBoard,CAPTURE_MISCCONTROL,-1);
	if(IsDlgButtonChecked(IDC_CHECK3))
	{
		info = info | 0x00000001;//ΪжϷʽ
		okSetCaptureParam(hBoard,CAPTURE_MISCCONTROL,info);
	}
	else 
	{
		info = info & 0xfffffffe;
		okSetCaptureParam(hBoard,CAPTURE_MISCCONTROL,info);
	}
	GetDlgItem(IDC_CHECK3)->EnableWindow(FALSE);

	no=okGetSeqCapture(hBoard,0,0);//ʼɼһ֡
	okConvertRect(hBoard,(TARGET)&blk,0,BUFFER,(short)no,1);
	InvalidateRect(NULL,FALSE);
	UpdateWindow();

	bActive = TRUE;

	hThread=CreateThread(NULL,0,ThreadFunc,hBoard,0, &ThreadID);//߳


}

void CGetSeqCaptureDlg::OnStop() 
{
	bActive = FALSE;
	CreateThread(NULL,0,ThreadTerminate,hBoard,0, NULL);//߳
}


void CGetSeqCaptureDlg::OnClose() 
{
	bActive = FALSE;
	TerminateThread(hThread,0);
	okGetSeqCapture(hBoard,NULL,-1);//ɼ
	okStopCapture(hBoard);
	okCloseBoard(hBoard);
	GlobalFree(lpbi);
	CDialog::OnClose();
}

long exSetBitmapHeader(LPBITMAPINFOHEADER lpbi,short width,short height, short bits, short form)
{
	long	wbytes;

	if(!lpbi)
		return FALSE;

	
	if(form==FORM_RGB555)
		bits=16;
	wbytes=((((width*bits)+31)&~31)>>3);//bmp need 4 byte align

	lpbi->biWidth=width;
	lpbi->biHeight=height;

	lpbi->biSize=sizeof(BITMAPINFOHEADER);
	lpbi->biPlanes=1;

	lpbi->biBitCount=bits;
	lpbi->biSizeImage=wbytes*height;


	lpbi->biClrUsed=0;
	//special format for 555,565 & 32 
	if(form==FORM_RGB555 || form==FORM_RGB565 || form==FORM_RGB8888 ) 
		lpbi->biCompression=BI_BITFIELDS;
	else
		lpbi->biCompression=0;
	if(lpbi->biCompression==BI_BITFIELDS ) {//
		DWORD	*lpmask;
		lpmask=(DWORD *)((LPSTR)lpbi+lpbi->biSize);

		if(form==FORM_RGB555) {
			lpmask[2]=0x001f; //blue
			lpmask[1]=0x03e0;
			lpmask[0]=0x7c00;
		}
		else if(form==FORM_RGB565) {
			lpmask[2]=0x001f; //blue
			lpmask[1]=0x07e0;
			lpmask[0]=0xf800;
		}
		else if(bits==32 ) {
			lpmask[2]=0x0000ff;
			lpmask[1]=0x00ff00;
			lpmask[0]=0xff0000;
		}
	}
	else if(bits<=14) { // 8,10,12
		int		i,ratio;
		RGBQUAD	*lpRGB=(RGBQUAD *)((LPSTR)lpbi+lpbi->biSize);

		lpbi->biClrUsed=(1<<bits);
		ratio=lpbi->biClrUsed/256;

		for(i=0; i<(short)lpbi->biClrUsed;i++) {
			lpRGB[i].rgbBlue=i/ratio;
			lpRGB[i].rgbGreen=i/ratio;
			lpRGB[i].rgbRed=i/ratio;
			lpRGB[i].rgbReserved=0;
		}
	
	} 
	lpbi->biClrImportant=lpbi->biClrUsed;

	return lpbi->biClrUsed;
}

float exCalcCaptureRatio(long *num,DWORD *times)
{
	if( (*num>=12) || ((okGetTickCount()-(*times))>2000) ) 
	{
		*times=okGetTickCount()-(*times);
		ratio=((float)(*num)*1000/(*times));
		*num=0;
	}
	
	if(*num==0)
		(*times)=okGetTickCount();
	(*num)++;
	
	return ratio;
}

DWORD WINAPI ThreadFunc(LPVOID hBoard)
{

	int		no;
	long	i;
	LPBYTE	lpbuf;
	short	height;
	MLONG	stride;
	DWORD	StartTime, ElapsedTime;
	char	string[20];



	while(bActive)
	{

		StartTime = okGetTickCount();
		no=okGetSeqCapture(hBoard,NULL,1); //ÿһʱɼһ֡Ѳɼͼ֡
		ElapsedTime =okGetTickCount()-StartTime;

		lpbuf=(LPBYTE)okGetTargetInfo(hBoard,BUFFER,no,NULL,&height,&stride); 
	
		if(IsDlgButtonChecked(hWnd,IDC_CHECK1))
		{
			GetLocalTime( &sys ); 
		 	sprintf(date,"%02d:%02d:%02d",sys.wHour,sys.wMinute,sys.wSecond); 
			RECT	rect= {550,25,0,0};
			textmode.wFrameNo=SHORT(no);
			okSetTextTo(hBoard, BUFFER, &rect, &lfLogFont, &textmode,date, 8); 
		}

		if(IsDlgButtonChecked(hWnd,IDC_CHECK2))
		{
			for(i=0;i<=height*stride;i++)
			{
				*(lpbuf+i)=*(lpbuf+i)>128 ? 255:0;
			}		
		}
	
		okConvertRect(hBoard,(TARGET)&blk,0,BUFFER,no,1);
		InvalidateRect(hWnd,NULL,FALSE);
	 	UpdateWindow(hWnd);
	
		sprintf(string,"%5d",no);
		AfxGetApp()->m_pMainWnd->SetDlgItemText(IDC_NUMBER,string);
	
		sprintf(string,"%5u",ElapsedTime);
		AfxGetApp()->m_pMainWnd->SetDlgItemText(IDC_TIME,string);

		sprintf(string,"%5.2f",exCalcCaptureRatio(&num,&times));
		AfxGetApp()->m_pMainWnd->SetDlgItemText(IDC_RATIO,string);
	
	}
//	MessageBox(NULL,"1","1",MB_OK);
	return 0;
}

DWORD WINAPI ThreadTerminate(LPVOID hBoard)
{
	DWORD dwState=WAIT_TIMEOUT;
	int i;
	i = GetTickCount();
	while((dwState==WAIT_TIMEOUT)&&((i - GetTickCount())<200))
	{
		dwState = WaitForSingleObject(hThread,0);
		Sleep(1);
		i = GetTickCount();
	}
	if(dwState==WAIT_TIMEOUT)
	{
		TerminateThread(hThread,0);
//		MessageBox(NULL,"1","1",MB_OK);
	}
	CloseHandle(hThread);
	okGetSeqCapture(hBoard,NULL,-1);//ɼ
	EnableWindow(GetDlgItem(hWnd,IDC_CHECK3),TRUE);
//	MessageBox(NULL,"ɼѽ","ʾ",MB_OK);
	return 0;
}
