// GraphOverlayDlg.cpp : implementation file
//

#include "stdafx.h"
#include "GraphOverlay.h"
#include "GraphOverlayDlg.h"

#include "okapi32.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

HWND hWnd;
LPBITMAPINFOHEADER	lpbi;
LPBYTE				lpdib;
BLOCKINFO			blk;

long		num;
DWORD		times;
float		ratio;

BOOL CALLBACK BeginCapture(HANDLE hBoard);
BOOL CALLBACK Process(HANDLE hBoard, long no);
BOOL CALLBACK EndCapture(HANDLE hBoard);
long exSetBitmapHeader(LPBITMAPINFOHEADER lpbi,short width,short height, short bits, short form);
float exCalcCaptureRatio(long *num,DWORD *times);
long exGetTargetSize(HANDLE hBoard, TARGET tgt, short *width, short *height);

/////////////////////////////////////////////////////////////////////////////
// CGraphOverlayDlg dialog

CGraphOverlayDlg::CGraphOverlayDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGraphOverlayDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGraphOverlayDlg)
	m_Radio = -1;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_ICON1);
}

void CGraphOverlayDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGraphOverlayDlg)
	DDX_Control(pDX, IDC_IMAGE, m_image);
	DDX_Radio(pDX, IDC_RADIO1, m_Radio);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CGraphOverlayDlg, CDialog)
	//{{AFX_MSG_MAP(CGraphOverlayDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(ID_START, OnStart)
	ON_BN_CLICKED(ID_STOP, OnStop)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_RADIO1, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio2)
	ON_BN_CLICKED(IDC_RADIO3, OnRadio3)
	ON_BN_CLICKED(IDC_RADIO4, OnRadio4)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGraphOverlayDlg message handlers

BOOL CGraphOverlayDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	//***************************************************************//
	//************ open card and initialize the application *********//
	long	lIndex=-1;
	RECT		Rect;	
	hBoard=okOpenBoard(&lIndex);

	Rect.right=-1;
	okSetTargetRect(hBoard,BUFFER,&Rect);

	lpbi=(LPBITMAPINFOHEADER)GlobalAlloc(GPTR,
		(Rect.right - Rect.left)*(Rect.bottom- Rect.top)*4+5120);

	lpdib=(LPBYTE)lpbi+5120;
	hWnd=AfxGetApp()->m_pMainWnd->m_hWnd;

	int lRe = okSetVideoParam(hBoard, VIDEO_ENABLEGRAPHS, 0x000);		// default: no overlay
	if(lRe<0)
	{
		MessageBox("ǰ豸֧ͼλӹܣ", NULL, MB_OK);
		return TRUE;
	}

	((CButton*)GetDlgItem(IDC_RADIO1))-> SetCheck(1);

	//***************************************************************//
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CGraphOverlayDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDC *cdc;
 		RECT rect;
 
 		cdc=m_image.GetDC();
 	
 		m_image.GetClientRect(&rect);
 		SetStretchBltMode(cdc->m_hDC,STRETCH_HALFTONE);
 		StretchDIBits(cdc->m_hDC,
 			rect.left,rect.top,
 			rect.right,rect.bottom, 
 			0,0, //horzstart, vertstart, 
 			lpbi->biWidth,lpbi->biHeight,
 			lpdib,(LPBITMAPINFO)lpbi, 
 			DIB_RGB_COLORS,SRCCOPY);

 		ReleaseDC(cdc);


		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CGraphOverlayDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CGraphOverlayDlg::OnStart() 
{
	GetDlgItem(ID_START)->EnableWindow(FALSE);
	okSetSeqCallback(hBoard,BeginCapture,Process,EndCapture);
//	okCaptureSequence(hBoard,0,-1); //жϷʽ
	okCaptureTo(hBoard,BUFFER,0,-1);
}

void CGraphOverlayDlg::OnStop() 
{
	okStopCapture(hBoard);
	okSetSeqCallback(hBoard,NULL,NULL,NULL);
	GetDlgItem(ID_START)->EnableWindow(TRUE);		
}

void CGraphOverlayDlg::OnClose() 
{
	okStopCapture(hBoard);	
	okCloseBoard(hBoard);
	
	CDialog::OnClose();
}

BOOL CALLBACK BeginCapture(HANDLE hBoard)
{	
	short		width,height;
	long		form;
	
	exGetTargetSize(hBoard, BUFFER, &width, &height);
	form=okSetCaptureParam(hBoard,CAPTURE_SCRRGBFORMAT,GETCURRPARAM); //-1
	exSetBitmapHeader(lpbi, width, height, HIWORD(form), LOWORD(form) );
	blk.lpBits=lpdib;
	blk.iBitCount=lpbi->biBitCount;
	blk.iHeight =-(short)lpbi->biHeight;
	blk.iWidth =(short)lpbi->biWidth;
	return 1;
}
LOGFONT 	lfLogFont={ -20, 0, 0, 0, 400, 0, 0, 0, 0, 1, 2, 1, 26, "Arial"};
SETTEXTMODE	textmode={0x0,0xffffff,2,0,0};  //


BOOL CALLBACK Process(HANDLE hBoard,long no)
{	
	LPBYTE	lpbuf;
	short	height;
	long	stride;
	char	str[50];
	
    lpbuf=(LPBYTE)okGetTargetInfo(hBoard,BUFFER,no,NULL,&height,&stride); 
	sprintf(str,"%5.2f",exCalcCaptureRatio(&num,&times));
	AfxGetApp()->m_pMainWnd->SetDlgItemText(IDC_RATIO,str);
	sprintf(str,"%d",no);
	AfxGetApp()->m_pMainWnd->SetDlgItemText(IDC_NUMBER,str);
	okConvertRect(hBoard, (TARGET)&blk, 0, BUFFER, no, 1);
	InvalidateRect(hWnd,NULL,FALSE);
	UpdateWindow(hWnd);
	
	return 1;
}


BOOL CALLBACK EndCapture(HANDLE hBoard)
{
	okSetSeqCallback(hBoard,NULL,NULL,NULL);
//	okStopCapture(hBoard);
	
	return 1;
}


long exSetBitmapHeader(LPBITMAPINFOHEADER lpbi,short width,short height, short bits, short form)
{
	long	wbytes;

	if(!lpbi)
		return FALSE;

	
	if(form==FORM_RGB555)
		bits=16;
	wbytes=((((width*bits)+31)&~31)>>3);//bmp need 4 byte align

	lpbi->biWidth=width;
	lpbi->biHeight=height;

	lpbi->biSize=sizeof(BITMAPINFOHEADER);
	lpbi->biPlanes=1;

	lpbi->biBitCount=bits;
	lpbi->biSizeImage=wbytes*height;


	lpbi->biClrUsed=0;
	//special format for 555,565 & 32 
	if(form==FORM_RGB555 || form==FORM_RGB565 || form==FORM_RGB8888 ) 
		lpbi->biCompression=BI_BITFIELDS;
	else
		lpbi->biCompression=0;
	if(lpbi->biCompression==BI_BITFIELDS ) {//
		DWORD	*lpmask;
		lpmask=(DWORD *)((LPSTR)lpbi+lpbi->biSize);

		if(form==FORM_RGB555) {
			lpmask[2]=0x001f; //blue
			lpmask[1]=0x03e0;
			lpmask[0]=0x7c00;
		}
		else if(form==FORM_RGB565) {
			lpmask[2]=0x001f; //blue
			lpmask[1]=0x07e0;
			lpmask[0]=0xf800;
		}
		else if(bits==32 ) {
			lpmask[2]=0x0000ff;
			lpmask[1]=0x00ff00;
			lpmask[0]=0xff0000;
		}
	}
	else if(bits<=14) { // 8,10,12
		int		i,ratio;
		RGBQUAD	*lpRGB=(RGBQUAD *)((LPSTR)lpbi+lpbi->biSize);

		lpbi->biClrUsed=(1<<bits);
		ratio=lpbi->biClrUsed/256;

		for(i=0; i<(short)lpbi->biClrUsed;i++) {
			lpRGB[i].rgbBlue=i/ratio;
			lpRGB[i].rgbGreen=i/ratio;
			lpRGB[i].rgbRed=i/ratio;
			lpRGB[i].rgbReserved=0;
		}
	
	} 
	lpbi->biClrImportant=lpbi->biClrUsed;

	return lpbi->biClrUsed;
}

float exCalcCaptureRatio(long *num,DWORD *times)
{
	if( (*num>=12) || ((okGetTickCount()-(*times))>2000) ) 
	{
		*times=okGetTickCount()-(*times);
		ratio=((float)(*num)*1000/(*times));
		*num=0;
	}
	
	if(*num==0)
		(*times)=okGetTickCount();
	(*num)++;
	
	return ratio;
}

long exGetTargetSize(HANDLE hBoard, TARGET tgt, short *width, short *height)
{
	RECT	rect;
	long	form;
	
	
	if( (tgt==SCREEN ) ||(tgt==BUFFER) ) {
		rect.right=-1;
		okSetTargetRect(hBoard,tgt,&rect); //get current rect
		if(width)
			*width=(short)(rect.right-rect.left);
		if(height)
			*height=(short)(rect.bottom-rect.top);
		
		if(tgt==SCREEN ) {
			form=okSetCaptureParam(hBoard,CAPTURE_SCRRGBFORMAT,GETCURRPARAM); //-1
			//limit to video rect
			rect.right=-1; //max. captured rect
			okSetTargetRect(hBoard,VIDEO,&rect); //get video rect
			if(width)
				*width=(short)min(*width,rect.right-rect.left);
			if(height)
				*height=(short)min(*height,rect.bottom-rect.top);
		}
		else if(tgt==BUFFER) 
			form=okSetCaptureParam(hBoard,CAPTURE_BUFRGBFORMAT,GETCURRPARAM); //-1
		
	} else if(tgt>BUFFER) { //from blkinfo
		LPBLOCKINFO	lpblk;
		lpblk=(LPBLOCKINFO)tgt;
		
		if(width)
			*width=lpblk->iWidth;
		if(height)
			*height=abs(lpblk->iHeight);
		form=MAKELONG(lpblk->iFormType,lpblk->iBitCount);
	}
	
	
	return form;
}




void CGraphOverlayDlg::OnRadio1() 
{
	okSetVideoParam(hBoard, VIDEO_ENABLEGRAPHS, 0x000);
}

void CGraphOverlayDlg::OnRadio2() 
{

	SETTEXTMODE	textmode={0xffffff,0x0,FULLCOPY,0,0};  //
	LPBYTE		lpGraph;
	short		wid,ht;
	long		stride;
	RECT		rcRect;

	rcRect.right=-1;
	okSetTargetRect(hBoard,BUFFER,&rcRect);

	rcRect.left+=(rcRect.right-rcRect.left-rcRect.bottom+rcRect.top)/2;
	rcRect.right-=(rcRect.right-rcRect.left-rcRect.bottom+rcRect.top)/2;

	//select cap-graph frm0
	okSetVideoParam(hBoard, VIDEO_ENABLEGRAPHS, 0x001);
	lpGraph=(LPBYTE)okGetTargetInfo(hBoard, GRAPH, 0, &wid, &ht, &stride);
	if(lpGraph) //clear
	{
		ZeroMemory(lpGraph, stride*ht);// ZeroMemory
	}
	okFillCircleTo(hBoard, (TARGET)GRAPH, 0, &rcRect, 1, 0);
	RECT rect = {0,0,0,0};
	okSetTextTo(hBoard, (TARGET)GRAPH, &rect, &lfLogFont, &textmode, " JOINHOPEκ", 16); 		
	POINT	pt0={(rcRect.right-rcRect.left)/2, 0};
	POINT	pt1={(rcRect.right-rcRect.left)/2, rcRect.bottom};
	POINT	pt2={0, (rcRect.bottom-rcRect.top)/2};
	POINT	pt3={rcRect.right, (rcRect.bottom-rcRect.top)/2};
	okDrawLineTo(hBoard,(TARGET)GRAPH,0,pt0,pt1,0xff);
	okDrawLineTo(hBoard,(TARGET)GRAPH,0,pt2,pt3,0xff);

	//select cap-graph frm1
	okSetVideoParam(hBoard, VIDEO_ENABLEGRAPHS, 0x201);
	if(lpGraph) //clear
	{
		ZeroMemory(lpGraph, stride*ht);// ZeroMemory
	}
	okFillCircleTo(hBoard, (TARGET)GRAPH, 0, &rcRect, 1, 0);
	SetRect(&rect,0,0,0,0);
	okSetTextTo(hBoard, (TARGET)GRAPH, &rect, &lfLogFont, &textmode, " JOINHOPEκ", 16); 
	okDrawLineTo(hBoard,(TARGET)GRAPH,0,pt0,pt1,0xff);
	okDrawLineTo(hBoard,(TARGET)GRAPH,0,pt2,pt3,0xff);
}

void CGraphOverlayDlg::OnRadio3() 
{
	//-------output graph overlay---------------------------------------------------


	SETTEXTMODE	textmode={0xffffff,0x0,FULLCOPY,0,0};  //
	LPBYTE		lpGraph;
	short		wid,ht;
	long		stride;
	RECT		rcRect;

	rcRect.right=-1;
	okSetTargetRect(hBoard,BUFFER,&rcRect);

	rcRect.left+=(rcRect.right-rcRect.left-rcRect.bottom+rcRect.top)/2;
	rcRect.right-=(rcRect.right-rcRect.left-rcRect.bottom+rcRect.top)/2;

	//select out-graph frm0
	okSetVideoParam(hBoard, VIDEO_ENABLEGRAPHS, 0x102);
	lpGraph=(LPBYTE)okGetTargetInfo(hBoard, GRAPH, 0, &wid, &ht, &stride);
	if(lpGraph) //clear
	{
		ZeroMemory(lpGraph, stride*ht);// ZeroMemory
	}
	okFillCircleTo(hBoard, (TARGET)GRAPH, 0, &rcRect, 1, 0);
	RECT rect = {0,0,0,0};
	okSetTextTo(hBoard, (TARGET)GRAPH, &rect, &lfLogFont, &textmode, " JOINHOPEκ", 16); 		
	POINT	pt0={(rcRect.right-rcRect.left)/2, 0};
	POINT	pt1={(rcRect.right-rcRect.left)/2, rcRect.bottom};
	POINT	pt2={0, (rcRect.bottom-rcRect.top)/2};
	POINT	pt3={rcRect.right, (rcRect.bottom-rcRect.top)/2};
	okDrawLineTo(hBoard,(TARGET)GRAPH,0,pt0,pt1,0xff);
	okDrawLineTo(hBoard,(TARGET)GRAPH,0,pt2,pt3,0xff);

	//select out-graph frm1
	okSetVideoParam(hBoard, VIDEO_ENABLEGRAPHS, 0x302);
	if(lpGraph) //clear
	{
		ZeroMemory(lpGraph, stride*ht);// ZeroMemory
	}
	okFillCircleTo(hBoard, (TARGET)GRAPH, 0, &rcRect, 1, 0);
	SetRect(&rect,0,0,0,0);
	okSetTextTo(hBoard, (TARGET)GRAPH, &rect, &lfLogFont, &textmode, " JOINHOPEκ", 16); 
	okDrawLineTo(hBoard,(TARGET)GRAPH,0,pt0,pt1,0xff);
	okDrawLineTo(hBoard,(TARGET)GRAPH,0,pt2,pt3,0xff);
	
}

void CGraphOverlayDlg::OnRadio4() 
{

	SETTEXTMODE	textmode={0xffffff,0x0,FULLCOPY,0,0};  //
	LPBYTE		lpGraph;
	short		wid,ht;
	long		stride;
	RECT		rcRect;

	rcRect.right=-1;
	okSetTargetRect(hBoard,BUFFER,&rcRect);

	rcRect.left+=(rcRect.right-rcRect.left-rcRect.bottom+rcRect.top)/2;
	rcRect.right-=(rcRect.right-rcRect.left-rcRect.bottom+rcRect.top)/2;

	//select cap-graph frm0
	okSetVideoParam(hBoard, VIDEO_ENABLEGRAPHS, 0x003);
	lpGraph=(LPBYTE)okGetTargetInfo(hBoard, GRAPH, 0, &wid, &ht, &stride);
	if(lpGraph) //clear
	{
		ZeroMemory(lpGraph, stride*ht);// ZeroMemory
	}
	okFillCircleTo(hBoard, (TARGET)GRAPH, 0, &rcRect, 1, 0);
	RECT rect = {0,0,0,0};
	okSetTextTo(hBoard, (TARGET)GRAPH, &rect, &lfLogFont, &textmode, " JOINHOPEκ", 16); 		
	POINT	pt0={(rcRect.right-rcRect.left)/2, 0};
	POINT	pt1={(rcRect.right-rcRect.left)/2, rcRect.bottom};
	POINT	pt2={0, (rcRect.bottom-rcRect.top)/2};
	POINT	pt3={rcRect.right, (rcRect.bottom-rcRect.top)/2};
	okDrawLineTo(hBoard,(TARGET)GRAPH,0,pt0,pt1,0xff);
	okDrawLineTo(hBoard,(TARGET)GRAPH,0,pt2,pt3,0xff);

	//select cap-graph frm1
	okSetVideoParam(hBoard, VIDEO_ENABLEGRAPHS, 0x203);
	if(lpGraph) //clear
	{
		ZeroMemory(lpGraph, stride*ht);// ZeroMemory
	}
	okFillCircleTo(hBoard, (TARGET)GRAPH, 0, &rcRect, 1, 0);
	SetRect(&rect,0,0,0,0);
	okSetTextTo(hBoard, (TARGET)GRAPH, &rect, &lfLogFont, &textmode, " JOINHOPEκ", 16); 
	okDrawLineTo(hBoard,(TARGET)GRAPH,0,pt0,pt1,0xff);
	okDrawLineTo(hBoard,(TARGET)GRAPH,0,pt2,pt3,0xff);

	//select out-graph frm0

	okSetVideoParam(hBoard, VIDEO_ENABLEGRAPHS, 0x103);
//	lpGraph=(LPBYTE)okGetTargetInfo(hBoard, GRAPH, 0, &wid, &ht, &stride);
	if(lpGraph) //clear
	{
		ZeroMemory(lpGraph, stride*ht);// ZeroMemory
	}
	okFillCircleTo(hBoard, (TARGET)GRAPH, 0, &rcRect, 1, 0);
	SetRect(&rect,0,0,0,0);
	okSetTextTo(hBoard, (TARGET)GRAPH, &rect, &lfLogFont, &textmode, " JOINHOPEκ", 16); 
	okDrawLineTo(hBoard,(TARGET)GRAPH,0,pt0,pt1,0xff);
	okDrawLineTo(hBoard,(TARGET)GRAPH,0,pt2,pt3,0xff);

	//select out-graph frm1
	okSetVideoParam(hBoard, VIDEO_ENABLEGRAPHS, 0x303);
	if(lpGraph) //clear
	{
		ZeroMemory(lpGraph, stride*ht);// ZeroMemory
	}
	okFillCircleTo(hBoard, (TARGET)GRAPH, 0, &rcRect, 1, 0);
	SetRect(&rect,0,0,0,0);
	okSetTextTo(hBoard, (TARGET)GRAPH, &rect, &lfLogFont, &textmode, " JOINHOPEκ", 16); 
	okDrawLineTo(hBoard,(TARGET)GRAPH,0,pt0,pt1,0xff);
	okDrawLineTo(hBoard,(TARGET)GRAPH,0,pt2,pt3,0xff);
}

BOOL CGraphOverlayDlg::DestroyWindow() 
{
	GlobalFree(lpbi);
	
	return CDialog::DestroyWindow();
}
