// MaskCaptureDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MaskCapture.h"
#include "MaskCaptureDlg.h"

#include "okapi32.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

BOOL DemoMask(HANDLE hBoard);
CWnd* cWnd;
HWND hWnd;
RECT imageRect;
BOOL bline;
BOOL bcircle; 
BOOL bcharacter;
BOOL blogo;
LPBITMAPINFOHEADER	lpbi;
LPBYTE				lpdib;
BLOCKINFO	blk;
BOOL CALLBACK BeginCapture(HANDLE hBoard);
BOOL CALLBACK Process(HANDLE hBoard, long no);
BOOL CALLBACK EndCapture(HANDLE hBoard);
long exSetBitmapHeader(LPBITMAPINFOHEADER lpbi,short width,short height, short bits, short form);
long exGetTargetSize(HANDLE hBoard, TARGET tgt, short *width, short *height);
char    code[]="can not open the file.";

/////////////////////////////////////////////////////////////////////////////
// CMaskCaptureDlg dialog

CMaskCaptureDlg::CMaskCaptureDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMaskCaptureDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMaskCaptureDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDI_OKDEMO);
}

void CMaskCaptureDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMaskCaptureDlg)
	DDX_Control(pDX, IDC_IMAGE, m_image);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMaskCaptureDlg, CDialog)
	//{{AFX_MSG_MAP(CMaskCaptureDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMaskCaptureDlg message handlers

BOOL CMaskCaptureDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	//***************************************************************//
	//************ open card and initialize the application *********//

	cWnd = GetDlgItem(IDC_IMAGE);
	cWnd->GetWindowRect(&imageRect);
	ScreenToClient(&imageRect);
	cWnd->MoveWindow(imageRect.left, imageRect.top, 640, 480, FALSE); 

	long	lIndex = -1;   
	hBoard=okOpenBoard(&lIndex);
// 	okSetCaptureParam(hBoard,CAPTURE_BUFRGBFORMAT,FORM_GRAY8);
//	okSetCaptureParam(hBoard,CAPTURE_CLIPMODE,2);
	RECT	rect;
	rect.right=-1;
	okSetTargetRect(hBoard,BUFFER,&rect);
	lpbi=(LPBITMAPINFOHEADER)GlobalAlloc(GPTR,rect.right*rect.bottom*4+5120);
	lpdib=(LPBYTE)lpbi+5120;

	hWnd=AfxGetApp()->m_pMainWnd->m_hWnd;
	CheckRadioButton(IDC_RADIO1,IDC_RADIO3,IDC_RADIO1);

	//***************************************************************//
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMaskCaptureDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDC *cdc;
		RECT rect;
		
		cdc=m_image.GetDC();
		
		m_image.GetClientRect(&rect);
		SetStretchBltMode(cdc->m_hDC,STRETCH_DELETESCANS);
		StretchDIBits(cdc->m_hDC,
			rect.left,rect.top,
			rect.right,rect.bottom, 
			0,0, //horzstart, vertstart, 
			lpbi->biWidth,lpbi->biHeight,
			lpdib,(LPBITMAPINFO)lpbi, 
			DIB_RGB_COLORS,SRCCOPY);
		
 		ReleaseDC(cdc);
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMaskCaptureDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMaskCaptureDlg::OnStart() 
{
// 	RECT rect;
// 	
// 	SetRect(&rect,0,0,768,576);
// 	okSetTargetRect(hBoard,BUFFER,&rect);//Set Buffer Rect
	
	if (IsDlgButtonChecked(IDC_CHECK1))
		bline=1;
	else
		bline=0;	
	if (IsDlgButtonChecked(IDC_CHECK2))
		bcircle=1;
	else
		bcircle=0;
	if (IsDlgButtonChecked(IDC_CHECK3))
		bcharacter=1; 
	else
		bcharacter=0;
	if (IsDlgButtonChecked(IDC_CHECK4))
		blogo=1;
	else
		blogo=0;
	
	DemoMask(hBoard);

	if(IsDlgButtonChecked(IDC_RADIO1))
		okEnableMask(hBoard,0);
	else if(IsDlgButtonChecked(IDC_RADIO2))
		okEnableMask(hBoard,1);
	else
	   	okEnableMask(hBoard,2);	
	   
	okSetSeqCallback(hBoard,BeginCapture,Process,EndCapture);
//	okCaptureSequence(hBoard,0,-1); //жϷʽ
    okCaptureTo(hBoard,BUFFER,0,-1);
}

void CMaskCaptureDlg::OnStop() 
{
 	okStopCapture(hBoard);	
}

void CMaskCaptureDlg::OnClose() 
{
	okStopCapture(hBoard);
	okCloseBoard(hBoard);
	GlobalFree(lpbi);

	CDialog::OnClose();
}

//***************************DemoMask*******************************
BOOL DemoMask(HANDLE hBoard)
{

	RECT		rect;
	BYTE		lpMask[640*480];
	BLOCKINFO	blk;
	LOGFONT 	lfLogFont={ -20, 0, 0, 0, 400, 0, 0, 0, 0, 1, 2, 1, 26, "Arial"};
	SETTEXTMODE	textmode={0xffffff,0x0,1,0,0};  //
    
	rect.left=0;
 	rect.top=0;
 	rect.right=640;
 	rect.bottom=480;
	FillMemory(lpMask,640*480,1);
	okSetMaskRect(hBoard,&rect,lpMask);
         
    if (bcircle==1)//Բ
    {
		HANDLE	hDCBitmap;
		HDC		hdcMem1;
	
		FillMemory(lpMask,307200,0); //set bits to init 
		blk.lpBits=lpMask;
		blk.iBitCount=8;
		blk.iWidth=640;
		blk.iHeight=480; 

		hdcMem1=okCreateDCBitmap( hBoard, (TARGET)&blk, &hDCBitmap);
		Ellipse(hdcMem1,80,0,560,480);
		okMapDCBitmapTo(hDCBitmap,0);
		okFreeDCBitmap(hDCBitmap);
		SetRect(&rect,0,0,640,480);
		okSetMaskRect(hBoard,&rect,lpMask);

	}
	if(bcharacter==1)//ַ
	{
		RECT	rect= {0,0,0,0};
		
		FillMemory(lpMask,40000,0); //set bits to init 
		blk.lpBits=lpMask;
		blk.iBitCount=8;
		blk.iWidth=100;
		blk.iHeight=30; 
		okSetTextTo(hBoard, (TARGET)&blk, &rect, &lfLogFont, &textmode, "κ", 8); 		
		SetRect(&rect,500,10,500+100,10+30);	 //set characters
		okSetMaskRect(hBoard,&rect,lpMask);
		
		FillMemory(lpMask,40000,0); //set bits to init 
		SetRect(&rect,0,0,0,0);	 //set characters
		okSetTextTo(hBoard, (TARGET)&blk, &rect, &lfLogFont, &textmode, "JoinHope", 8); 
		SetRect(&rect,500,40,500+100,40+30);	 //set chinese characters
		okSetMaskRect(hBoard,&rect,lpMask);
	}
    if(bline==1) //ʮ
	{
		POINT Ps,Pe;
		
		FillMemory(lpMask,100*100,1); //set bits to init 
		blk.lpBits=lpMask;
		blk.iBitCount=8;
		blk.iWidth=100;
		blk.iHeight=100; 			
		Ps.x=50;Ps.y=0;
		Pe.x=50;Pe.y=100;
		okDrawLineTo(hBoard,(TARGET)&blk,0,Ps,Pe,RGB(0,0,0));
		SetRect(&rect,270,190,370,290);	 //set characters
		okSetMaskRect(hBoard,&rect,lpMask);
		
		Ps.x=0;Ps.y=50;
		Pe.x=100;Pe.y=50;
		okDrawLineTo(hBoard,(TARGET)&blk,0,Ps,Pe,RGB(0,0,0));
		SetRect(&rect,270,190,370,290);	 //set characters
		okSetMaskRect(hBoard,&rect,lpMask);
	}
	if(blogo==1)//ͼ
	{ 
		HANDLE	hDCBitmap;
		HDC		hdcMem;
		
		FillMemory(lpMask,307200,0); //set bits to init 
		blk.lpBits=lpMask;
		blk.iBitCount=8;
		blk.iWidth=76;
		blk.iHeight=58; 
		
		hdcMem=okCreateDCBitmap( hBoard, (TARGET)&blk, &hDCBitmap);
		BITMAPFILEHEADER bmfHeader;
		LPBITMAPINFOHEADER	lpFbi;
		LPBYTE				lpFdib;
		HFILE hFile;
		OFSTRUCT	OfStruct;   
		DWORD dwFileSize,read;
			
		hFile=OpenFile("xiaobiao.bmp",&OfStruct, OF_READ);
		if (hFile!=-1)
		{	
			dwFileSize=GetFileSize((HANDLE)hFile,NULL);	
			ReadFile((HANDLE)hFile,&bmfHeader,sizeof(bmfHeader),&read,NULL);	
			lpFbi=(LPBITMAPINFOHEADER)GlobalAlloc(GPTR,dwFileSize);	
			ReadFile((HANDLE)hFile,lpFbi,dwFileSize-sizeof(bmfHeader),&read,NULL);		
			lpFdib=(LPBYTE)lpFbi+bmfHeader.bfOffBits-sizeof(bmfHeader);		
			
			SetStretchBltMode(hdcMem,STRETCH_DELETESCANS);
			StretchDIBits(hdcMem,
				0,0,
				76,58, 
				0,0, 
				lpFbi->biWidth,lpFbi->biHeight,
				lpFdib,(LPBITMAPINFO)lpFbi,
				DIB_RGB_COLORS,NOTSRCCOPY);
			
			GlobalFree(lpFbi);					
			okMapDCBitmapTo(hDCBitmap,0);		
			okFreeDCBitmap(hDCBitmap);
			SetRect(&rect,20,20,96,78);		
			okSetMaskRect(hBoard,&rect,lpMask);
		}
		else
		{
			MessageBox(hWnd,code,NULL,MB_OK);
		}
		
	}

		
			return 1;
}
//********************************************************************
//****************CALLBACK FUNCTION***********************************
BOOL CALLBACK BeginCapture(HANDLE hBoard)
{ 
	LPBYTE		lpLinear;
	DWORD		dwSize;
	short		width,height;
	long		form;
	okGetBufferSize(hBoard,(void **)&lpLinear,&dwSize);
	ZeroMemory(lpLinear,dwSize); 		
	exGetTargetSize(hBoard, BUFFER, &width, &height);
	form=okSetCaptureParam(hBoard,CAPTURE_SCRRGBFORMAT,GETCURRPARAM); //-1
	exSetBitmapHeader(lpbi, width, height, HIWORD(form), LOWORD(form) );
	blk.lpBits=lpdib;
	blk.iBitCount=lpbi->biBitCount;
	blk.iHeight =-(short)lpbi->biHeight;
	blk.iWidth =(short)lpbi->biWidth;

	return  1;
}

BOOL CALLBACK Process(HANDLE hBoard,long no)
{	
	okConvertRect(hBoard,(TARGET)&blk,0,BUFFER,no,1);
	InvalidateRect(hWnd,NULL,FALSE);
 	UpdateWindow(hWnd);

	return 1;
}

BOOL CALLBACK EndCapture(HANDLE hBoard)
{
	okSetSeqCallback(hBoard,NULL,NULL,NULL);
// 	okStopCapture(hBoard);

	return 1;
}

//********************************************************************

long exGetTargetSize(HANDLE hBoard, TARGET tgt, short *width, short *height)
{
	RECT	rect;
	long	form;


	if( (tgt==SCREEN ) ||(tgt==BUFFER) ) {
		rect.right=-1;
		okSetTargetRect(hBoard,tgt,&rect); //get current rect
		if(width)
			*width=(short)(rect.right-rect.left);
		if(height)
			*height=(short)(rect.bottom-rect.top);

		if(tgt==SCREEN ) {
			form=okSetCaptureParam(hBoard,CAPTURE_SCRRGBFORMAT,GETCURRPARAM); //-1
			//limit to video rect
			rect.right=-1; //max. captured rect
			okSetTargetRect(hBoard,VIDEO,&rect); //get video rect
			if(width)
				*width=(short)min(*width,rect.right-rect.left);
			if(height)
				*height=(short)min(*height,rect.bottom-rect.top);
		}
		else if(tgt==BUFFER) 
			form=okSetCaptureParam(hBoard,CAPTURE_BUFRGBFORMAT,GETCURRPARAM); //-1

	} else if(tgt>BUFFER) { //from blkinfo
		LPBLOCKINFO	lpblk;
		lpblk=(LPBLOCKINFO)tgt;

		if(width)
			*width=lpblk->iWidth;
		if(height)
			*height=abs(lpblk->iHeight);
		form=MAKELONG(lpblk->iFormType,lpblk->iBitCount);
	}


	return form;
}

long exSetBitmapHeader(LPBITMAPINFOHEADER lpbi,short width,short height, short bits, short form)
{
	long	wbytes;

	if(!lpbi)
		return FALSE;

	
	if(form==FORM_RGB555)
		bits=16;
	wbytes=((((width*bits)+31)&~31)>>3);//bmp need 4 byte align

	lpbi->biWidth=width;
	lpbi->biHeight=height;

	lpbi->biSize=sizeof(BITMAPINFOHEADER);
	lpbi->biPlanes=1;

	lpbi->biBitCount=bits;
	lpbi->biSizeImage=wbytes*height;


	lpbi->biClrUsed=0;
	//special format for 555,565 & 32 
	if(form==FORM_RGB555 || form==FORM_RGB565 || form==FORM_RGB8888 ) 
		lpbi->biCompression=BI_BITFIELDS;
	else
		lpbi->biCompression=0;
	if(lpbi->biCompression==BI_BITFIELDS ) {//
		DWORD	*lpmask;
		lpmask=(DWORD *)((LPSTR)lpbi+lpbi->biSize);

		if(form==FORM_RGB555) {
			lpmask[2]=0x001f; //blue
			lpmask[1]=0x03e0;
			lpmask[0]=0x7c00;
		}
		else if(form==FORM_RGB565) {
			lpmask[2]=0x001f; //blue
			lpmask[1]=0x07e0;
			lpmask[0]=0xf800;
		}
		else if(bits==32 ) {
			lpmask[2]=0x0000ff;
			lpmask[1]=0x00ff00;
			lpmask[0]=0xff0000;
		}
	}
	else if(bits<=14) { // 8,10,12
		int		i,ratio;
		RGBQUAD	*lpRGB=(RGBQUAD *)((LPSTR)lpbi+lpbi->biSize);

		lpbi->biClrUsed=(1<<bits);
		ratio=lpbi->biClrUsed/256;

		for(i=0; i<(short)lpbi->biClrUsed;i++) {
			lpRGB[i].rgbBlue=i/ratio;
			lpRGB[i].rgbGreen=i/ratio;
			lpRGB[i].rgbRed=i/ratio;
			lpRGB[i].rgbReserved=0;
		}
	
	} 
	lpbi->biClrImportant=lpbi->biClrUsed;

	return lpbi->biClrUsed;
}

