// MulCallbackDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MulCallback.h"
#include "MulCallbackDlg.h"

#ifdef _WIN64
#include "okapi64.h"
#else
#include "okapi32.h"
#endif

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define BOARD_NUMBER	4   	//number of board in the computer,this
								//param can be received by okGetSlotBoard(
HANDLE lphBoard[]={0,0,0,0};

long		num0,num1,num2,num3 ;
DWORD		times0,times1,times2,times3;
float		ratio0,ratio1,ratio2,ratio3;
BLOCKINFO	blk0,blk1,blk2,blk3;
LPBITMAPINFOHEADER	lpbi[BOARD_NUMBER];
LPBYTE				lpdib[BOARD_NUMBER];
HWND		hWnd;
BOOL CALLBACK BeginCapture(HANDLE hBoard);
BOOL CALLBACK Process(HANDLE hBoard, MLONG no);
BOOL CALLBACK EndCapture(HANDLE hBoard);
long exSetBitmapHeader(LPBITMAPINFOHEADER lpbi,short width,short height, short bits, short form);
long exGetTargetSize(HANDLE hBoard, TARGET tgt, short *width, short *height);
float exCalcCaptureRatio0(long *num,DWORD *times);
float exCalcCaptureRatio1(long *num,DWORD *times);
float exCalcCaptureRatio2(long *num,DWORD *times);
float exCalcCaptureRatio3(long *num,DWORD *times);

/////////////////////////////////////////////////////////////////////////////
// CMulCallbackDlg dialog

CMulCallbackDlg::CMulCallbackDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMulCallbackDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMulCallbackDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDI_OKDEMO);
}

void CMulCallbackDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMulCallbackDlg)
	DDX_Control(pDX, IDC_IMAGE4, m_image4);
	DDX_Control(pDX, IDC_IMAGE3, m_image3);
	DDX_Control(pDX, IDC_IMAGE2, m_image2);
	DDX_Control(pDX, IDC_IMAGE1, m_image1);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMulCallbackDlg, CDialog)
	//{{AFX_MSG_MAP(CMulCallbackDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMulCallbackDlg message handlers

BOOL CMulCallbackDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	//************ open card and initialize the application *********//
	MLONG	lIndex;
	MWORD	dwBufSize;
	RECT	rect;

	//ĴС
	okGetAvailBuffer(NULL, &dwBufSize);
	dwBufSize=dwBufSize/BOARD_NUMBER;
	for(lIndex=0;lIndex<BOARD_NUMBER;lIndex++)
	{
		//򿪿
		lphBoard[lIndex]=okOpenBoard(&lIndex);
		if (lphBoard[lIndex])
		{
			//
			okLockBuffer(lphBoard[lIndex], dwBufSize , NULL); 
			//ûĿȺ͸߶ȣʾͼڴ
			rect.right=-1;
			okSetTargetRect(lphBoard[lIndex],BUFFER,&rect);
			lpbi[lIndex]=(LPBITMAPINFOHEADER)GlobalAlloc(GPTR,rect.right*rect.bottom*4+5120);
			lpdib[lIndex]=(LPBYTE)lpbi[lIndex]+5120;
		}
	}
	hWnd=AfxGetApp()->m_pMainWnd->m_hWnd;
	//***************************************************************//
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMulCallbackDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDC *cdc1,*cdc2,*cdc3,*cdc4;
		RECT rect;

		if((BOARD_NUMBER>=1)&&lpbi[0])
		{
			cdc1=m_image1.GetDC();
			m_image1.GetClientRect(&rect);
			SetStretchBltMode(cdc1->m_hDC,STRETCH_DELETESCANS);
			StretchDIBits(cdc1->m_hDC,
				rect.left+1,rect.top+1,
				rect.right-2,rect.bottom-2, 
				0,0, //horzstart, vertstart, 
				lpbi[0]->biWidth,lpbi[0]->biHeight,
				lpdib[0],(LPBITMAPINFO)lpbi[0], 
				DIB_RGB_COLORS,SRCCOPY);
			ReleaseDC(cdc1);
		}

		if ((BOARD_NUMBER>=2)&&lpbi[1])
		{
			cdc2=m_image2.GetDC();
			m_image2.GetClientRect(&rect);
			SetStretchBltMode(cdc2->m_hDC,STRETCH_DELETESCANS);
			StretchDIBits(cdc2->m_hDC,
				rect.left+1,rect.top+1,
				rect.right-2,rect.bottom-2, 
				0,0, //horzstart, vertstart, 
				lpbi[1]->biWidth,lpbi[1]->biHeight,
				lpdib[1],(LPBITMAPINFO)lpbi[1], 
				DIB_RGB_COLORS,SRCCOPY);
			ReleaseDC(cdc2);
		}
		if ((BOARD_NUMBER>=3)&&lpbi[2])
		{
			cdc3=m_image3.GetDC();
			m_image3.GetClientRect(&rect);
			SetStretchBltMode(cdc3->m_hDC,STRETCH_DELETESCANS);
			StretchDIBits(cdc3->m_hDC,
				rect.left+1,rect.top+1,
				rect.right-2,rect.bottom-2, 
				0,0, //horzstart, vertstart, 
				lpbi[2]->biWidth,lpbi[2]->biHeight,
				lpdib[2],(LPBITMAPINFO)lpbi[2], 
				DIB_RGB_COLORS,SRCCOPY);
			ReleaseDC(cdc3);
		}
		if ((BOARD_NUMBER>=4)&&lpbi[3])
		{
			cdc4=m_image4.GetDC();
			m_image4.GetClientRect(&rect);
			SetStretchBltMode(cdc4->m_hDC,STRETCH_DELETESCANS);
			StretchDIBits(cdc4->m_hDC,
				rect.left+1,rect.top+1,
				rect.right-2,rect.bottom-2, 
				0,0, //horzstart, vertstart, 
				lpbi[3]->biWidth,lpbi[3]->biHeight,
				lpdib[3],(LPBITMAPINFO)lpbi[3], 
				DIB_RGB_COLORS,SRCCOPY);
			ReleaseDC(cdc4);
		}
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMulCallbackDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMulCallbackDlg::OnStart() 
{
	for(int i=0;i<BOARD_NUMBER;i++)
	{
		okSetSeqCallback(lphBoard[i],BeginCapture,Process,EndCapture);
	// 	okCaptureSequence(lphBoard[i],0,-1); //жϷʽ
		okCaptureTo(lphBoard[i],BUFFER,0,-1);
	}

}

void CMulCallbackDlg::OnStop() 
{
	for(int i=0;i<BOARD_NUMBER;i++)
	{
		okStopCapture(lphBoard[i]);
	}
}

void CMulCallbackDlg::OnClose() 
{
	int i;
	for(i=0;i<BOARD_NUMBER;i++)
	{
		okStopCapture(lphBoard[i]);
		okCloseBoard(lphBoard[i]);
		GlobalFree(lpbi[i]);
	}

	okUnlockAllBuffer();

	CDialog::OnClose();
}

//****************CALLBACK FUNCTION***********************************

float exCalcCaptureRatio0(long *num,DWORD *times)
{
	if( (*num>=12) || ((okGetTickCount()-(*times))>2000) ) {
		*times=okGetTickCount()-(*times);
		ratio0=((float)(*num)*1000/(*times));
		*num=0;
	}

	if(*num==0)
		(*times)=okGetTickCount();
	(*num)++;

	return ratio0;
}

float exCalcCaptureRatio1(long *num,DWORD *times)
{
	if( (*num>=12) || ((okGetTickCount()-(*times))>2000) ) {
		*times=okGetTickCount()-(*times);
		ratio1=((float)(*num)*1000/(*times));
		*num=0;
	}

	if(*num==0)
		(*times)=okGetTickCount();
	(*num)++;

	return ratio1;
}

float exCalcCaptureRatio2(long *num,DWORD *times)
{
	if( (*num>=12) || ((okGetTickCount()-(*times))>2000) ) {
		*times=okGetTickCount()-(*times);
		ratio2=((float)(*num)*1000/(*times));
		*num=0;
	}

	if(*num==0)
		(*times)=okGetTickCount();
	(*num)++;

	return ratio2;
}

float exCalcCaptureRatio3(long *num,DWORD *times)
{
	if( (*num>=12) || ((okGetTickCount()-(*times))>2000) ) {
		*times=okGetTickCount()-(*times);
		ratio3=((float)(*num)*1000/(*times));
		*num=0;
	}

	if(*num==0)
		(*times)=okGetTickCount();
	(*num)++;

	return ratio3;
}

BOOL CALLBACK BeginCapture(HANDLE hBoard)
{
	short		width,height;
	long		form;

	if(hBoard==lphBoard[0])
	{
		num0=0;
		times0=0;
		exGetTargetSize(hBoard, BUFFER, &width, &height);
		form=okSetCaptureParam(hBoard,CAPTURE_SCRRGBFORMAT,GETCURRPARAM); //-1
		exSetBitmapHeader(lpbi[0], width, height, HIWORD(form), LOWORD(form) );
		blk0.lpBits=lpdib[0];
		blk0.iBitCount=lpbi[0]->biBitCount;
		blk0.iHeight =-(short)lpbi[0]->biHeight;
		blk0.iWidth =(short)lpbi[0]->biWidth;

	}

	else if(hBoard==lphBoard[1])
	{
		num1=0;
		times1=0;
		exGetTargetSize(hBoard, BUFFER, &width, &height);
		form=okSetCaptureParam(hBoard,CAPTURE_SCRRGBFORMAT,GETCURRPARAM); //-1
		exSetBitmapHeader(lpbi[1], width, height, HIWORD(form), LOWORD(form) );
		blk1.lpBits=lpdib[1];
		blk1.iBitCount=lpbi[1]->biBitCount;
		blk1.iHeight=-(short)lpbi[1]->biHeight;
		blk1.iWidth=(short)lpbi[1]->biWidth;

	}

	else if(hBoard==lphBoard[2])
	{
		num2=0;
		times2=0;
		exGetTargetSize(hBoard, BUFFER, &width, &height);
		form=okSetCaptureParam(hBoard,CAPTURE_SCRRGBFORMAT,GETCURRPARAM); //-1
		exSetBitmapHeader(lpbi[2], width, height, HIWORD(form), LOWORD(form) );
		blk2.lpBits=lpdib[2];
		blk2.iBitCount=lpbi[2]->biBitCount;
		blk2.iHeight=-(short)lpbi[2]->biHeight;
		blk2.iWidth=(short)lpbi[2]->biWidth;

	}

	else if(hBoard==lphBoard[3])
	{
		num3=0;
		times3=0;
		exGetTargetSize(hBoard, BUFFER, &width, &height);
		form=okSetCaptureParam(hBoard,CAPTURE_SCRRGBFORMAT,GETCURRPARAM); //-1
		exSetBitmapHeader(lpbi[3], width, height, HIWORD(form), LOWORD(form) );
		blk3.lpBits=lpdib[3];
		blk3.iBitCount=lpbi[3]->biBitCount;
		blk3.iHeight=-(short)lpbi[3]->biHeight;
		blk3.iWidth=(short)lpbi[3]->biWidth;

	}

	return 1;
}

BOOL CALLBACK Process(HANDLE hBoard,MLONG no)
{	
	RECT rect;
	char string[200];
	if(hBoard==lphBoard[0])
	{	
		sprintf(string,"%5.2f",exCalcCaptureRatio0(&num0,&times0));
		AfxGetApp()->m_pMainWnd->SetDlgItemText(IDC_RATIO1,string);
		okConvertRect(hBoard,(TARGET)&blk0,0,BUFFER,no,1);

	}
	else if(hBoard==lphBoard[1])
	{
		sprintf(string,"%5.2f",exCalcCaptureRatio1(&num1,&times1));
		AfxGetApp()->m_pMainWnd->SetDlgItemText(IDC_RATIO2,string);
		okConvertRect(hBoard,(TARGET)&blk1,0,BUFFER,no,1);
	}
	
	else if(hBoard==lphBoard[2])
	{
		sprintf(string,"%5.2f",exCalcCaptureRatio2(&num2,&times2));
		AfxGetApp()->m_pMainWnd->SetDlgItemText(IDC_RATIO3,string);
		okConvertRect(hBoard,(TARGET)&blk2,0,BUFFER,no,1);
	}
	
	else if(hBoard==lphBoard[3])
	{
		sprintf(string,"%5.2f",exCalcCaptureRatio3(&num3,&times3));
		AfxGetApp()->m_pMainWnd->SetDlgItemText(IDC_RATIO4,string);
		okConvertRect(hBoard,(TARGET)&blk3,0,BUFFER,no,1);
	}	
	InvalidateRect(hWnd,NULL,FALSE);
	UpdateWindow(hWnd);
	
	return 1;
}

BOOL CALLBACK EndCapture(HANDLE hBoard)
{
	okSetSeqCallback(hBoard,NULL,NULL,NULL);

	return 1;
}
//********************************************************************

long exGetTargetSize(HANDLE hBoard, TARGET tgt, short *width, short *height)
{
	RECT	rect;
	long	form;

	if( (tgt==SCREEN ) ||(tgt==BUFFER) ) {
		rect.right=-1;
		okSetTargetRect(hBoard,tgt,&rect); //get current rect
		if(width)
			*width=(short)(rect.right-rect.left);
		if(height)
			*height=(short)(rect.bottom-rect.top);

		if(tgt==SCREEN ) {
			form=okSetCaptureParam(hBoard,CAPTURE_SCRRGBFORMAT,GETCURRPARAM); //-1
			//limit to video rect
			rect.right=-1; //max. captured rect
			okSetTargetRect(hBoard,VIDEO,&rect); //get video rect
			if(width)
				*width=(short)min(*width,rect.right-rect.left);
			if(height)
				*height=(short)min(*height,rect.bottom-rect.top);
		}
		else if(tgt==BUFFER) 
			form=okSetCaptureParam(hBoard,CAPTURE_BUFRGBFORMAT,GETCURRPARAM); //-1

	} else if(tgt>BUFFER) { //from blkinfo
		LPBLOCKINFO	lpblk;
		lpblk=(LPBLOCKINFO)tgt;

		if(width)
			*width=lpblk->iWidth;
		if(height)
			*height=abs(lpblk->iHeight);
		form=MAKELONG(lpblk->iFormType,lpblk->iBitCount);
	}


	return form;
}

long exSetBitmapHeader(LPBITMAPINFOHEADER lpbi,short width,short height, short bits, short form)
{
	long	wbytes;

	if(!lpbi)
		return FALSE;


	if(form==FORM_RGB555)
		bits=16;
	wbytes=((((width*bits)+31)&~31)>>3);//bmp need 4 byte align

	lpbi->biWidth=width;
	lpbi->biHeight=height;

	lpbi->biSize=sizeof(BITMAPINFOHEADER);
	lpbi->biPlanes=1;

	lpbi->biBitCount=bits;
	lpbi->biSizeImage=wbytes*height;


	lpbi->biClrUsed=0;
	//special format for 555,565 & 32 
	if(form==FORM_RGB555 || form==FORM_RGB565 || form==FORM_RGB8888 || form==FORM_RGB8886) 
		lpbi->biCompression=BI_BITFIELDS;
	else
		lpbi->biCompression=0;
	if(lpbi->biCompression==BI_BITFIELDS ) {//
		DWORD	*lpmask;
		lpmask=(DWORD *)((LPSTR)lpbi+lpbi->biSize);

		if(form==FORM_RGB555) {
			lpmask[2]=0x001f; //blue
			lpmask[1]=0x03e0;
			lpmask[0]=0x7c00;
		}
		else if(form==FORM_RGB565) {
			lpmask[2]=0x001f; //blue
			lpmask[1]=0x07e0;
			lpmask[0]=0xf800;
		}
		else if(bits==32 ) {
			lpmask[2]=0x0000ff;
			lpmask[1]=0x00ff00;
			lpmask[0]=0xff0000;
		}
	}
	else if(bits<=14) { // 8,10,12
		int		i,ratio;
		RGBQUAD	*lpRGB=(RGBQUAD *)((LPSTR)lpbi+lpbi->biSize);

		lpbi->biClrUsed=(1<<bits);
		ratio=lpbi->biClrUsed/256;

		for(i=0; i<(short)lpbi->biClrUsed;i++) {
			lpRGB[i].rgbBlue=i/ratio;
			lpRGB[i].rgbGreen=i/ratio;
			lpRGB[i].rgbRed=i/ratio;
			lpRGB[i].rgbReserved=0;
		}
	
	} 
	lpbi->biClrImportant=lpbi->biClrUsed;

	return lpbi->biClrUsed;
}
