// OutputImageDlg.cpp : implementation file
//

#include "stdafx.h"
#include "OutputImage.h"
#include "OutputImageDlg.h"
#include "Okapi32.h"
#include "okAutSet.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

HANDLE hBoard;
HWND hWnd;
char path[100];
char str[100];
RECT monitorrect;
LPBITMAPINFOHEADER	lpbi;
LPBYTE				lpdib;
BLOCKINFO	blk;
long bufformat;
short bufwidth,bufhight;
BOOL CALLBACK BeginCapture(HANDLE hBoard);
BOOL CALLBACK Process(HANDLE hBoard, long no);
BOOL CALLBACK EndCapture(HANDLE hBoard);
long exSetBitmapHeader(LPBITMAPINFOHEADER lpbi,short width,short height, short bits, short form);
long exGetTargetSize(HANDLE hBoard, TARGET tgt, short *width, short *height);
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COutputImageDlg dialog

COutputImageDlg::COutputImageDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COutputImageDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(COutputImageDlg)
	m_scr = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDI_OKDEMO);
}

void COutputImageDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COutputImageDlg)
	DDX_Control(pDX, IDC_LINEPERIOD, m_lineperiod);
	DDX_Control(pDX, IDC_MONITORY, m_monitory);
	DDX_Control(pDX, IDC_MONITORX, m_monitorx);
	DDX_Control(pDX, IDC_OUTYOFFSET, m_outyoffset);
	DDX_Control(pDX, IDC_OUTXOFFSET, m_outxoffset);
	DDX_Control(pDX, IDC_OUTHORZPIX, m_outhorzpix);
	DDX_Control(pDX, IDC_FRAMELINES, m_framelines);
	DDX_Control(pDX, IDC_IMAGE, m_image);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(COutputImageDlg, CDialog)
	//{{AFX_MSG_MAP(COutputImageDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_FILEPATH, OnFilepath)
	ON_BN_CLICKED(IDC_RADIO7, OnRadio7)
	ON_BN_CLICKED(IDC_RADIO6, OnRadio6)
	ON_BN_CLICKED(IDC_RADIO8, OnRadio8)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_AUTOSET, OnAutoset)
	ON_CBN_SELCHANGE(IDC_OUTSIGNALTYPE, OnSelchangeOutsignaltype)
	ON_CBN_SELCHANGE(IDC_SYNC, OnSelchangeSync)
	ON_BN_CLICKED(IDC_SETPARAM, OnSetparam)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COutputImageDlg message handlers

BOOL COutputImageDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	SCROLLINFO  si;
	long	lIndex = -1;
	hBoard=okOpenBoard(&lIndex);
	int i=okSetVideoParam(hBoard,VIDEO_FRAMELINES,-1);
	if (i == -1)
	{
		strcpy(str,"ÿñ");
		MessageBox(str,"WARNING",MB_OK);
	}

 	bufformat=okSetCaptureParam(hBoard,CAPTURE_BUFRGBFORMAT,-1);
	okGetTargetInfo(hBoard,BUFFER,0,&bufwidth,&bufhight,NULL);//õǰĻ
	lpbi=(LPBITMAPINFOHEADER)GlobalAlloc(GPTR,bufwidth*bufhight*4+5120);//ڴʾ,ڴСͼС
	lpdib=(LPBYTE)lpbi+5120;
	hWnd=AfxGetApp()->m_pMainWnd->m_hWnd;
	CheckRadioButton(IDC_RADIO6,IDC_RADIO8,IDC_RADIO8);
	i=LOWORD(i);
	if (i==625)
	{
		CheckRadioButton(IDC_RADIO1,IDC_RADIO5,IDC_RADIO1);
	}
	else if (i==525)
	{
		CheckRadioButton(IDC_RADIO1,IDC_RADIO5,IDC_RADIO2);
	}
	else if (i==628)
	{
		CheckRadioButton(IDC_RADIO1,IDC_RADIO5,IDC_RADIO3);
	}
	else if (i==806)
	{
		CheckRadioButton(IDC_RADIO1,IDC_RADIO5,IDC_RADIO4);
	}
	else if (i==1066)
	{
		CheckRadioButton(IDC_RADIO1,IDC_RADIO5,IDC_RADIO5);
	}
	else 
 		CheckRadioButton(IDC_RADIO1,IDC_RADIO5,IDC_RADIO1);
	GetDlgItem(IDC_FILEPATH)->EnableWindow(false);
	
	si.cbSize=sizeof(SCROLLINFO);
	si.fMask=SIF_ALL;
	si.nMax=1024;
	si.nMin=0;
	si.nPage=16;
	i=okSetVideoParam(hBoard,VIDEO_LINEPERIOD,-1);
	WORD z=HIWORD(i);
	if (z==0)
	{
		si.nPos = 0.54 * (LOWORD(i)+1);
		si.nPos*=10;
	}
	else
		si.nPos = LOWORD(i);
	m_lineperiod.SetScrollInfo(&si,TRUE);
	sprintf(str,"%d",si.nPos);
	SetDlgItemText(IDC_PERIOD,str);
	si.nMax=2048;
	si.nMin=128;
	si.nPos=LOWORD(okSetVideoParam(hBoard,VIDEO_FRAMELINES,-1));
	m_framelines.SetScrollInfo(&si,TRUE);
	sprintf(str,"%d",si.nPos);
	SetDlgItemText(IDC_LINES,str);
	si.nMax=4096;
	si.nMin=0;
	si.nPos=okSetVideoParam(hBoard,VIDEO_OUTHORZPIX,-1);
	m_outhorzpix.SetScrollInfo(&si,TRUE);
	sprintf(str,"%d",si.nPos);
	SetDlgItemText(IDC_XPIXEL,str);
	si.nMax=4096;
	si.nMin=0;
	monitorrect.right=-1;
	okSetTargetRect(hBoard,MONITOR,&monitorrect);
	si.nPos=monitorrect.left;
	m_outxoffset.SetScrollInfo(&si,TRUE);
	sprintf(str,"%d",si.nPos);
	SetDlgItemText(IDC_XSTART,str);
	si.nMax=3072;
	si.nMin=0;
	si.nPos=monitorrect.top;
	m_outyoffset.SetScrollInfo(&si,TRUE);
	sprintf(str,"%d",si.nPos);
	SetDlgItemText(IDC_YSTRART,str);
	si.nMax=4096;
	si.nMin=0;
	si.nPos=monitorrect.right-monitorrect.left;
	m_monitorx.SetScrollInfo(&si,TRUE);
	sprintf(str,"%d",si.nPos);
	SetDlgItemText(IDC_XWIDTH,str);
	si.nMax=3072;
	si.nMin=0;
	si.nPos=monitorrect.bottom-monitorrect.top;
	m_monitory.SetScrollInfo(&si,TRUE);
	sprintf(str,"%d",si.nPos);
	SetDlgItemText(IDC_YHIGHT,str);
	CComboBox* m_sync=(CComboBox *)GetDlgItem(IDC_SYNC);
	if (okSetVideoParam(hBoard,VIDEO_FRAMELINES,0xffff)==1)
		m_sync->SetCurSel(0);
	else
		m_sync->SetCurSel(1);
	
	CComboBox* m_outtype=(CComboBox *)GetDlgItem(IDC_OUTSIGNALTYPE);
	i=okSetVideoParam(hBoard,VIDEO_OUTSIGNALTYPE,-1);
	if (i==7)
	{
		m_outtype->SetCurSel(0);
	}
	else if (i==3)
	{
		m_outtype->SetCurSel(1);
	}
	else if (i==0)
	{
		m_outtype->SetCurSel(2);
	}
	else if (i==4)
	{
		m_outtype->SetCurSel(3);
	}

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void COutputImageDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void COutputImageDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDC *cdc;
		RECT rect;
		
		cdc=m_image.GetDC();
		
		m_image.GetClientRect(&rect);
		SetStretchBltMode(cdc->m_hDC,STRETCH_DELETESCANS);
		StretchDIBits(cdc->m_hDC,
			rect.left,rect.top,
			rect.right,rect.bottom, 
			0,0, //horzstart, vertstart, 
			lpbi->biWidth,lpbi->biHeight,
			lpdib,(LPBITMAPINFO)lpbi, 
			DIB_RGB_COLORS,SRCCOPY);
		
 		ReleaseDC(cdc);
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR COutputImageDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void COutputImageDlg::OnStart() 
{
	RECT rect;
	int num,len;
		
	okSetSeqCallback(hBoard,BeginCapture,Process,EndCapture);
	
	if (IsDlgButtonChecked(IDC_RADIO8))//ɼ
	{
		okSetCaptureParam(hBoard,CAPTURE_BUFRGBFORMAT,bufformat);
		SetRect(&rect,0,0,bufwidth,bufhight);
		okSetTargetRect(hBoard,BUFFER,&rect);
// 		num=okGetBufferSize(hBoard,NULL,NULL);
// 	//	okCaptureSequence(hBoard,0,-1);
		okCaptureTo(hBoard,BUFFER,0,-1);
	}
	
	if(IsDlgButtonChecked(IDC_RADIO6))//طŻ
	{
 		okSetCaptureParam(hBoard,CAPTURE_BUFRGBFORMAT,bufformat);
		SetRect(&rect,0,0,bufwidth,bufhight);
		okSetTargetRect(hBoard,BUFFER,&rect);
		num=okGetBufferSize(hBoard,NULL,NULL);
		okPlaybackFrom(hBoard,BUFFER,0,-num);
	}
		
	if(IsDlgButtonChecked(IDC_RADIO7))//طļ
	{		
		len=strlen(path);
		if (len==0)
		{
			strcpy(str,"ָļ·");
			MessageBox(str,"ERROR",MB_OK);
			return;
		}
		num=okLoadImageFile(hBoard,path,0,SCREEN,0,0);
		if (num==0)
		{
			strcpy(str,"ļʧܣָļ·");
			MessageBox(str,"ERROR",MB_OK);
			return;
		}
		else
		{
			GlobalFree(lpbi);//ͷڴ
			okGetTargetInfo(hBoard,BUFFER,0,&bufwidth,&bufhight,NULL);//õǰĻߣڴ
			lpbi=(LPBITMAPINFOHEADER)GlobalAlloc(GPTR,bufwidth*bufhight*4+5120);//ڴʾ,ڴСͼС
			lpdib=(LPBYTE)lpbi+5120;
		}
		
		
		okPlaybackByBuffer(hBoard,(TARGET)path,0,num);
		
	}	
	
}

void COutputImageDlg::OnStop() 
{
	okStopCapture(hBoard);	
}

void COutputImageDlg::OnClose() 
{
	okStopCapture(hBoard);
	okCloseBoard(hBoard);
	GlobalFree(lpbi);
	
	CDialog::OnClose();
}


void COutputImageDlg::OnFilepath() 
{
	okStopCapture(hBoard);
	CFileDialog file(TRUE,NULL,NULL,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,"All Files (*.*)|*.*|Jpeg format file (*.JPG,JPEG)|*.JPG;*.JPEG|BMP file  (*.BMP)|*.BMP|Sequence file  (*.SEQ)|*.SEQ|Audio-video interleaved (*.AVI)|*.AVI|Mpeg2 Video stream (*.M2V)|*.M2V|Mpeg2 Video stream (*.MPG)|*.MPG|Jpeg2000 format file (*.JP2)|*.JP2||");
	
	if (file.DoModal()==IDOK)
	{
		CString   strFile   =   file.GetPathName();
		strcpy(path,strFile); 
	}
	
}


//****************CALLBACK FUNCTION***********************************

BOOL CALLBACK BeginCapture(HANDLE hBoard)
{	
	short		width,height;
	long		form;
	
	exGetTargetSize(hBoard, BUFFER, &width, &height);
	form=okSetCaptureParam(hBoard,CAPTURE_SCRRGBFORMAT,GETCURRPARAM); //-1
	exSetBitmapHeader(lpbi, width, height, HIWORD(form), LOWORD(form) );
	blk.lpBits=lpdib;
	blk.iBitCount=lpbi->biBitCount;
	blk.iHeight =-(short)lpbi->biHeight;
	blk.iWidth =(short)lpbi->biWidth;

	return 1;
}
    

BOOL CALLBACK Process(HANDLE hBoard,long no)
{	
	okConvertRect(hBoard,(TARGET)&blk,0,BUFFER,no,1);
	InvalidateRect(hWnd,NULL,FALSE);
 	UpdateWindow(hWnd);

	return 1;
}


BOOL CALLBACK EndCapture(HANDLE hBoard)
{
	okSetSeqCallback(hBoard,NULL,NULL,NULL);
// 	okStopCapture(hBoard);

	return 1;
}
//********************************************************************

long exGetTargetSize(HANDLE hBoard, TARGET tgt, short *width, short *height)
{
	RECT	rect;
	long	form;

	if( (tgt==SCREEN ) ||(tgt==BUFFER) ) {
		rect.right=-1;
		okSetTargetRect(hBoard,tgt,&rect); //get current rect
		if(width)
			*width=(short)(rect.right-rect.left);
		if(height)
			*height=(short)(rect.bottom-rect.top);

		if(tgt==SCREEN ) {
			form=okSetCaptureParam(hBoard,CAPTURE_SCRRGBFORMAT,GETCURRPARAM); //-1
			//limit to video rect
			rect.right=-1; //max. captured rect
			okSetTargetRect(hBoard,VIDEO,&rect); //get video rect
			if(width)
				*width=(short)min(*width,rect.right-rect.left);
			if(height)
				*height=(short)min(*height,rect.bottom-rect.top);
		}
		else if(tgt==BUFFER) 
			form=okSetCaptureParam(hBoard,CAPTURE_BUFRGBFORMAT,GETCURRPARAM); //-1

	} else if(tgt>BUFFER) { //from blkinfo
		LPBLOCKINFO	lpblk;
		lpblk=(LPBLOCKINFO)tgt;

		if(width)
			*width=lpblk->iWidth;
		if(height)
			*height=abs(lpblk->iHeight);
		form=MAKELONG(lpblk->iFormType,lpblk->iBitCount);
	}


	return form;
}

long exSetBitmapHeader(LPBITMAPINFOHEADER lpbi,short width,short height, short bits, short form)
{
	long	wbytes;

	if(!lpbi)
		return FALSE;

	
	if(form==FORM_RGB555)
		bits=16;
	wbytes=((((width*bits)+31)&~31)>>3);//bmp need 4 byte align

	lpbi->biWidth=width;
	lpbi->biHeight=height;

	lpbi->biSize=sizeof(BITMAPINFOHEADER);
	lpbi->biPlanes=1;

	lpbi->biBitCount=bits;
	lpbi->biSizeImage=wbytes*height;


	lpbi->biClrUsed=0;
	//special format for 555,565 & 32 
	if(form==FORM_RGB555 || form==FORM_RGB565 || form==FORM_RGB8888 ) 
		lpbi->biCompression=BI_BITFIELDS;
	else
		lpbi->biCompression=0;
	if(lpbi->biCompression==BI_BITFIELDS ) {//
		DWORD	*lpmask;
		lpmask=(DWORD *)((LPSTR)lpbi+lpbi->biSize);

		if(form==FORM_RGB555) {
			lpmask[2]=0x001f; //blue
			lpmask[1]=0x03e0;
			lpmask[0]=0x7c00;
		}
		else if(form==FORM_RGB565) {
			lpmask[2]=0x001f; //blue
			lpmask[1]=0x07e0;
			lpmask[0]=0xf800;
		}
		else if(bits==32 ) {
			lpmask[2]=0x0000ff;
			lpmask[1]=0x00ff00;
			lpmask[0]=0xff0000;
		}
	}
	else if(bits<=14) { // 8,10,12
		int		i,ratio;
		RGBQUAD	*lpRGB=(RGBQUAD *)((LPSTR)lpbi+lpbi->biSize);

		lpbi->biClrUsed=(1<<bits);
		ratio=lpbi->biClrUsed/256;

		for(i=0; i<(short)lpbi->biClrUsed;i++) {
			lpRGB[i].rgbBlue=i/ratio;
			lpRGB[i].rgbGreen=i/ratio;
			lpRGB[i].rgbRed=i/ratio;
			lpRGB[i].rgbReserved=0;
		}
	
	} 
	lpbi->biClrImportant=lpbi->biClrUsed;

	return lpbi->biClrUsed;
}



void COutputImageDlg::OnRadio7() 
{
	GetDlgItem(IDC_FILEPATH)->EnableWindow(true);
	
}

void COutputImageDlg::OnRadio6() 
{
	GetDlgItem(IDC_FILEPATH)->EnableWindow(false);
	
}

void COutputImageDlg::OnRadio8() 
{
	GetDlgItem(IDC_FILEPATH)->EnableWindow(false);
	
}

void COutputImageDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	int minpos;
	int maxpos;
	pScrollBar->GetScrollRange(&minpos, &maxpos); 
	maxpos = pScrollBar->GetScrollLimit();
	
	// Get the current position of scroll box.
	int curpos = pScrollBar->GetScrollPos();
	
	// Determine the new position of scroll box.
	switch (nSBCode)
	{
	case SB_LEFT:    // Scroll to far left.
		curpos = minpos;
		break;
		
	case SB_RIGHT:    // Scroll to far right.
		curpos = maxpos;
		break;
		
	case SB_ENDSCROLL:  // End scroll.
		break;
		
	case SB_LINELEFT:    // Scroll left.
		if (curpos > minpos)
			curpos--;
		break;
		
	case SB_LINERIGHT:  // Scroll right.
		if (curpos < maxpos)
			curpos++;
		break;
		
	case SB_PAGELEFT:   // Scroll one page left.
		{
			// Get the page size. 
			SCROLLINFO  info;
			pScrollBar->GetScrollInfo(&info, SIF_ALL);
			
			if (curpos > minpos)
				curpos = max(minpos, curpos - (int) info.nPage);
		}
		break;
		
	case SB_PAGERIGHT:    // Scroll one page right.
		{
			// Get the page size. 
			SCROLLINFO  info;
			pScrollBar->GetScrollInfo(&info, SIF_ALL);
			
			if (curpos < maxpos)
				curpos = min(maxpos, curpos + (int) info.nPage);
		}
		break;
		
	case SB_THUMBPOSITION: // Scroll to absolute position. nPos is the position
		curpos = nPos;      // of the scroll box at the end of the drag 
		// operation.
		break;
		
	case SB_THUMBTRACK:   // Drag scroll box to specified position. nPos is 
		// the
		curpos = nPos;     // position that the scroll box has been dragged 
		// to.
		break;
	}
	
	// Set the new position of the thumb (scroll box).
	pScrollBar->SetScrollPos(curpos);
	if (pScrollBar->GetDlgCtrlID()==IDC_LINEPERIOD)
	{
		okSetVideoParam(hBoard,VIDEO_LINEPERIOD,MAKELONG(curpos,1));
		sprintf(str,"%d",curpos);
		SetDlgItemText(IDC_PERIOD,str);
	}
	if (pScrollBar->GetDlgCtrlID()==IDC_FRAMELINES)
	{
		okSetVideoParam(hBoard,VIDEO_FRAMELINES,curpos);
		sprintf(str,"%d",curpos);
		SetDlgItemText(IDC_LINES,str);
	}
	if (pScrollBar->GetDlgCtrlID()==IDC_OUTHORZPIX)
	{
		okSetVideoParam(hBoard,VIDEO_OUTHORZPIX,curpos);
		sprintf(str,"%d",curpos);
		SetDlgItemText(IDC_XPIXEL,str);
	}
	if (pScrollBar->GetDlgCtrlID()==IDC_OUTXOFFSET)
	{
		monitorrect.right=-1;
		okSetTargetRect(hBoard,MONITOR,&monitorrect);
		int temp=monitorrect.right-monitorrect.left;
		SetRect(&monitorrect,curpos,monitorrect.top,curpos+temp,monitorrect.bottom);
		okSetTargetRect(hBoard,MONITOR,&monitorrect);
		
		sprintf(str,"%d",curpos);
		SetDlgItemText(IDC_XSTART,str);
	}
	if (pScrollBar->GetDlgCtrlID()==IDC_OUTYOFFSET)
	{
		monitorrect.right=-1;
		okSetTargetRect(hBoard,MONITOR,&monitorrect);
		int temp=monitorrect.bottom-monitorrect.top;
		SetRect(&monitorrect,monitorrect.left,curpos,monitorrect.right,curpos+temp);
		okSetTargetRect(hBoard,MONITOR,&monitorrect);
		sprintf(str,"%d",curpos);
		SetDlgItemText(IDC_YSTRART,str);
	}
	if (pScrollBar->GetDlgCtrlID()==IDC_MONITORX)
	{
		monitorrect.right=-1;
		okSetTargetRect(hBoard,MONITOR,&monitorrect);
		monitorrect.right=monitorrect.left+curpos;
		okSetTargetRect(hBoard,MONITOR,&monitorrect);
		sprintf(str,"%d",curpos);
		SetDlgItemText(IDC_XWIDTH,str);
	}
	if (pScrollBar->GetDlgCtrlID()==IDC_MONITORY)
	{
		monitorrect.right=-1;
		okSetTargetRect(hBoard,MONITOR,&monitorrect);
		monitorrect.bottom=monitorrect.top+curpos;
		okSetTargetRect(hBoard,MONITOR,&monitorrect);
		sprintf(str,"%d",curpos);
		SetDlgItemText(IDC_YHIGHT,str);
	}
	
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void COutputImageDlg::OnAutoset() 
{
	long id,i,Pos,len,num;
	RECT rect;
	okStopCapture(hBoard);

	if (IsDlgButtonChecked(IDC_RADIO8)||IsDlgButtonChecked(IDC_RADIO6))
	{
		okSetCaptureParam(hBoard,CAPTURE_BUFRGBFORMAT,bufformat);
		SetRect(&rect,0,0,bufwidth,bufhight);
		okSetTargetRect(hBoard,BUFFER,&rect);
			
	} 
	else
	{
		len=strlen(path);
		if (len==0)
		{
			strcpy(str,"ָļ·");
			MessageBox(str,"ERROR",MB_OK);
			return;
		}
		
		num=okLoadImageFile(hBoard,path,0,BUFFER,0,1);
		if (num==0)
		{
			strcpy(str,"ļʧܣָļ·");
			MessageBox(str,"ERROR",MB_OK);
			return;
		}
		
	}

	id=GetCheckedRadioButton(IDC_RADIO1,IDC_RADIO5);
	if (id==1002)
	{
		okAutoSetPlayBackParam(hBoard,0,0);
	} 
	else if(id==1003)
	{
		okAutoSetPlayBackParam(hBoard,0,1);
		
	}
	else if (id==1004)
	{
		okAutoSetPlayBackParam(hBoard,0,2);
		
	} 
	else if(id==1005)
	{
		okAutoSetPlayBackParam(hBoard,0,3);
		
	}
	else if(id==1006)
	{
		okAutoSetPlayBackParam(hBoard,0,4);
		
	}
	else
	{
		okAutoSetPlayBackParam(hBoard,0,0);
	}

	i=okSetVideoParam(hBoard,VIDEO_LINEPERIOD,-1);
	WORD z=HIWORD(i);
	if (z==0)
	{
		Pos = 0.54 * (LOWORD(i)+1);
		Pos*=10;
	}
	else
		Pos = LOWORD(i);

	CScrollBar *p=(CScrollBar * )GetDlgItem(IDC_LINEPERIOD);
	p->SetScrollPos(Pos);
	sprintf(str,"%d",Pos);
	SetDlgItemText(IDC_PERIOD,str);
	
	Pos=LOWORD(okSetVideoParam(hBoard,VIDEO_FRAMELINES,-1));
	p=(CScrollBar * )GetDlgItem(IDC_FRAMELINES);
	p->SetScrollPos(Pos);
	sprintf(str,"%d",Pos);
	SetDlgItemText(IDC_LINES,str);
	
	Pos=okSetVideoParam(hBoard,VIDEO_OUTHORZPIX,-1);
	p=(CScrollBar * )GetDlgItem(IDC_OUTHORZPIX);
	p->SetScrollPos(Pos);
	sprintf(str,"%d",Pos);
	SetDlgItemText(IDC_XPIXEL,str);
	
	monitorrect.right=-1;
	okSetTargetRect(hBoard,MONITOR,&monitorrect);
	Pos=monitorrect.left;
	p=(CScrollBar * )GetDlgItem(IDC_OUTXOFFSET);
	p->SetScrollPos(Pos);
	sprintf(str,"%d",Pos);
	SetDlgItemText(IDC_XSTART,str);
	
	Pos=monitorrect.top;
	p=(CScrollBar * )GetDlgItem(IDC_OUTYOFFSET);
	p->SetScrollPos(Pos);
	sprintf(str,"%d",Pos);
	SetDlgItemText(IDC_YSTRART,str);
		
	Pos=monitorrect.right-monitorrect.left;
	p=(CScrollBar * )GetDlgItem(IDC_MONITORX);
	p->SetScrollPos(Pos);
	sprintf(str,"%d",Pos);
	SetDlgItemText(IDC_XWIDTH,str);
	
	Pos=monitorrect.bottom-monitorrect.top;
	p=(CScrollBar * )GetDlgItem(IDC_MONITORY);
	p->SetScrollPos(Pos);
	sprintf(str,"%d",Pos);
	SetDlgItemText(IDC_YHIGHT,str);

	CComboBox* m_sync=(CComboBox *)GetDlgItem(IDC_SYNC);
	if (okSetVideoParam(hBoard,VIDEO_FRAMELINES,0xffff)==1)
		m_sync->SetCurSel(0);
	else
		m_sync->SetCurSel(1);
	
	CComboBox* m_outtype=(CComboBox *)GetDlgItem(IDC_OUTSIGNALTYPE);
	i=okSetVideoParam(hBoard,VIDEO_OUTSIGNALTYPE,-1);
	if (i==7)
	{
		m_outtype->SetCurSel(0);
	}
	else if (i==3)
	{
		m_outtype->SetCurSel(1);
	}
	else if (i==0)
	{
		m_outtype->SetCurSel(2);
	}
	else if (i==4)
	{
		m_outtype->SetCurSel(3);
	}
	
}

void COutputImageDlg::OnSelchangeOutsignaltype() 
{
	int i;
	CComboBox* m_outtype=(CComboBox *)GetDlgItem(IDC_OUTSIGNALTYPE);
	i = m_outtype->GetCurSel();
	if (i==0)
	{
		okSetVideoParam(hBoard,VIDEO_OUTSIGNALTYPE,7);
	}
	else if (i==1)
	{
		okSetVideoParam(hBoard,VIDEO_OUTSIGNALTYPE,3);
	}
	else if (i==2)
	{
		okSetVideoParam(hBoard,VIDEO_OUTSIGNALTYPE,0);
	}
	else if (i==3)
	{
		okSetVideoParam(hBoard,VIDEO_OUTSIGNALTYPE,4);
	}
	
}

void COutputImageDlg::OnSelchangeSync() 
{
	int i,j;
	CComboBox* m_sync=(CComboBox *)GetDlgItem(IDC_SYNC);
	i=m_sync->GetCurSel();
	j=okSetVideoParam(hBoard,VIDEO_FRAMELINES,-1);
	if (i==0)
	{
		okSetVideoParam(hBoard,VIDEO_FRAMELINES,MAKELONG(LOWORD(j),1));
	}	
	else
		okSetVideoParam(hBoard,VIDEO_FRAMELINES,MAKELONG(LOWORD(j),0));
	
}

void COutputImageDlg::OnSetparam() 
{
	okOpenSetParamDlg(hBoard,hWnd);
	bufformat=okSetCaptureParam(hBoard,CAPTURE_BUFRGBFORMAT,-1);
	GlobalFree(lpbi);//ͷڴ
	okGetTargetInfo(hBoard,BUFFER,0,&bufwidth,&bufhight,NULL);//õǰĻߣڴ
	lpbi=(LPBITMAPINFOHEADER)GlobalAlloc(GPTR,bufwidth*bufhight*4+5120);//ڴʾ,ڴСͼС
	lpdib=(LPBYTE)lpbi+5120;
	
}
