#include "qtcallback.h"
#include <QApplication>

long        totalelapsed;
long		numframe;
char		string[256];

BLOCKINFO	blk;
long		num;
float		ratio=25;
LPBITMAPINFOHEADER	lpbi = NULL;
LPBYTE				lpdib = NULL;
qtcallback  *mainwin;
long exGetTargetSize(HANDLE hBoard, TARGET tgt, short *width, short *height);
long exSetBitmapHeader(LPBITMAPINFOHEADER lpbi,short width,short height, short bits, short form);



int main(int argc, char *argv[])
{
    QApplication a(argc, argv);
    qtcallback w;
    w.show();
    mainwin = &w;
    return a.exec();
}

float exCalcCaptureRatio()
{
    static	DWORD	times;

    if( (num>=12) ||  ((okGetTickCount()-times)>2000)&&(num>=2) ) {
        times=okGetTickCount()-times;
        ratio=((float)num*1000/times);
        num=0;
    }

    if(num==0)
        times=okGetTickCount();
    num++;

    return ratio;
}

BOOL CALLBACK exBeginCapture(HANDLE hBoard)
{
    short		width,height;
    MLONG		form;
    {
      //  okGetTargetInfo(hBoard,BUFFER,0,&width,&height,nullptr);
        exGetTargetSize(hBoard, BUFFER, &width, &height);
        form=okSetCaptureParam(hBoard,CAPTURE_SCRRGBFORMAT,GETCURRPARAM);
        if((form<0)||(form ==0xffff))
        {

            form = 0x200004;
        }
        exSetBitmapHeader(lpbi, width, height, HIWORD(form), LOWORD(form));
    }

    blk.iType=BMPHEADER;  //data is dib format
    blk.lpBits=(LPBYTE)lpdib;
    blk.iBitCount=HIWORD(form);
    blk.iWidth=width;
    blk.iHeight=height; //note: minus is for invert dib in y by ConvertRect

    totalelapsed=okGetTickCount();
    numframe=0;

    num=0;

    return 1;
}

BOOL CALLBACK exBackDisplay(HANDLE hBoard, MLONG no)
{
    MLONG	elapsed=okGetTickCount();
    numframe++;
    okConvertRect(hBoard, (TARGET)&blk, 0, BUFFER, (short)no, 1);

    sprintf(string," Ratio = %5.2f;Total frames =%6i;Current =%6i;Paint times=%4i",exCalcCaptureRatio(),numframe, no,okGetTickCount()-elapsed);
#if defined(Q_OS_WIN32)
    SetWindowTextA((HWND)mainwin->winId(), string);
#endif
    return 1;
}

BOOL CALLBACK exEndCapture(HANDLE hBoard)
{
    sprintf(string,"Total frames = %d; elapsed time = %d ms",numframe,okGetTickCount()-totalelapsed);
#if defined(Q_OS_WIN32)
    SetWindowTextA((HWND)mainwin->winId(), string);
#endif
    //clear callback
    okSetSeqCallback(hBoard,NULL,NULL,NULL); //disable this way
    //okStopCapture(hBoard); //disable this way

    return 1;
}
//get target size
long exGetTargetSize(HANDLE hBoard, TARGET tgt, short *width, short *height)
{
    RECT	rect;
    long	form;


    if( (tgt==SCREEN ) ||(tgt==BUFFER) ) {
        rect.right=-1;
        okSetTargetRect(hBoard,tgt,&rect); //get current rect
        if(width)
            *width=(short)(rect.right-rect.left);
        if(height)
            *height=(short)(rect.bottom-rect.top);

        if(tgt==SCREEN ) {
            form=okSetCaptureParam(hBoard,CAPTURE_SCRRGBFORMAT,GETCURRPARAM); //-1
            //limit to video rect
            rect.right=-1; //max. captured rect
            okSetTargetRect(hBoard,VIDEO,&rect); //get video rect
            if(width)
                *width = (short)qMin(long(*width), long(rect.right-rect.left));
            if(height)
                *height = (short)qMin(long(*height), long(rect.bottom-rect.top));
        }
        else if(tgt==BUFFER)
            form=okSetCaptureParam(hBoard,CAPTURE_BUFRGBFORMAT,GETCURRPARAM); //-1

    } else if(tgt>BUFFER) { //from blkinfo
        LPBLOCKINFO	lpblk;
        lpblk=(LPBLOCKINFO)tgt;

        if(width)
            *width=lpblk->iWidth;
        if(height)
            *height=abs(lpblk->iHeight);
        form=MAKELONG(lpblk->iFormType,lpblk->iBitCount);
    }


    return form;
}

//set bitmap header and bitmap info if need
long exSetBitmapHeader(LPBITMAPINFOHEADER lpbi,short width,short height, short bits, short form)
{
    long	wbytes;
    if(!lpbi)
        return FALSE;
    if(form==FORM_RGB555)
        bits=16;
    wbytes=((((width*bits)+31)&~31)>>3);//bmp need 4 byte align

    lpbi->biWidth=width;
    lpbi->biHeight=height;

    lpbi->biSize=sizeof(BITMAPINFOHEADER);
    lpbi->biPlanes=1;

    lpbi->biBitCount=bits;
    lpbi->biSizeImage=wbytes*height;


    lpbi->biClrUsed=0;
    //special format for 555,565 & 32
    if(form==FORM_RGB555 || form==FORM_RGB565 || form==FORM_RGB8888 || form==FORM_RGB8886)
        lpbi->biCompression=BI_BITFIELDS;
    else
        lpbi->biCompression=0;
    if(lpbi->biCompression==BI_BITFIELDS ) {//
        DWORD	*lpmask;
        lpmask=(DWORD *)((LPSTR)lpbi+lpbi->biSize);

        if(form==FORM_RGB555) {
            lpmask[2]=0x001f; //blue
            lpmask[1]=0x03e0;
            lpmask[0]=0x7c00;
        }
        else if(form==FORM_RGB565) {
            lpmask[2]=0x001f; //blue
            lpmask[1]=0x07e0;
            lpmask[0]=0xf800;
        }
        else if(bits==32 ) {
            lpmask[2]=0x0000ff;
            lpmask[1]=0x00ff00;
            lpmask[0]=0xff0000;
        }
    }
    else if(bits<=14) { // 8,10,12
        int		i,ratio;
        RGBQUAD	*lpRGB=(RGBQUAD *)((LPSTR)lpbi+lpbi->biSize);

        lpbi->biClrUsed=(1<<bits);
        ratio=lpbi->biClrUsed/256;

        lpbi->biClrUsed = qMin((DWORD)256,lpbi->biClrUsed); //limit
        for(i=0; i<(short)lpbi->biClrUsed;i++) {
            lpRGB[i].rgbBlue=i;//i/ratio;
            lpRGB[i].rgbGreen=i;//i/ratio;
            lpRGB[i].rgbRed=i;//i/ratio;
            lpRGB[i].rgbReserved=0;
        }
    }
    lpbi->biClrImportant=lpbi->biClrUsed;

    return lpbi->biClrUsed;
}
