#ifndef QTCALLBACK_H
#define QTCALLBACK_H

#include <QMainWindow>

#if defined(Q_OS_WIN64)
    #include "Windows.h"
    #include "Okapi64.h"
#elif defined(Q_OS_WIN32)
    #include "windows.h"
    #include "Okapi32.h"
#else
    #include "../share/winsim.h"
    #include "../share/okapi64.h"
#endif


namespace Ui {
class qtcallback;
}

class qtcallback : public QMainWindow
{
    Q_OBJECT

public:
    explicit qtcallback(QWidget *parent = nullptr);
    ~qtcallback();
    void upPaint();

protected:
    bool eventFilter(QObject *obj, QEvent *event);

private slots:
    void on_start_clicked();

    void on_stop_clicked();

private:
    Ui::qtcallback *ui;
    HANDLE		hBoard;
    MLONG		iCurrUsedNo=-1;//
    long		dwBufSize;
    DWORD		dwMaxMemSize;
    DWORD		dwDIBCurrSize=1024*1024*4; //
    QString     qstr;
    HANDLE      exOpenCard();
    long        exAllocateDIBMemory(HANDLE hBoard );
};

#endif // QTCALLBACK_H
