// savebyhardwareDlg.cpp : implementation file
//

#include "stdafx.h"
#include "savebyhardware.h"
#include "savebyhardwareDlg.h"
#include "okapi32.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


HWND hWnd;
HANDLE hBoard,hStream;
LPBITMAPINFOHEADER	lpbi;
LPBYTE				lpdib;
BLOCKINFO	blk;
BOOL		streamcap=0;
long		elapsed;
DWORD       starttime;
char        szFileName[50];
int         node;
long exSetBitmapHeader(LPBITMAPINFOHEADER lpbi,short width,short height, short bits, short form);
long exGetTargetSize(HANDLE hBoard, TARGET tgt, short *width, short *height);
BOOL CALLBACK BeginCapture(HANDLE hBoard);
BOOL CALLBACK Process(HANDLE hBoard, long no);
BOOL CALLBACK EndCapture(HANDLE hBoard);

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	afx_msg void OnClose();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSavebyhardwareDlg dialog

CSavebyhardwareDlg::CSavebyhardwareDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSavebyhardwareDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSavebyhardwareDlg)
	m_bitrate = 3000;
	m_maxbitrate = 9000;
	m_quality = 75;
	m_picfrmrate = 100;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSavebyhardwareDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSavebyhardwareDlg)
	DDX_Control(pDX, IDC_PICTURE, m_image);
	DDX_Text(pDX, IDC_BITRATEMODE, m_bitrate);
	DDV_MinMaxLong(pDX, m_bitrate, 0, 65535);
	DDX_Text(pDX, IDC_MAXBITRATE, m_maxbitrate);
	DDV_MinMaxLong(pDX, m_maxbitrate, 0, 65535);
	DDX_Text(pDX, IDC_QUALITY, m_quality);
	DDV_MinMaxLong(pDX, m_quality, 0, 100);
	DDX_Text(pDX, IDC_PICFRMRATE, m_picfrmrate);
	DDV_MinMaxLong(pDX, m_picfrmrate, 0, 100);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSavebyhardwareDlg, CDialog)
	//{{AFX_MSG_MAP(CSavebyhardwareDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CAPTURE, OnCapture)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSavebyhardwareDlg message handlers

BOOL CSavebyhardwareDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	long	lIndex=-1;
	
	hBoard=okOpenBoard(&lIndex);
	hStream=okOpenStream(hBoard,0);
	if (hStream)
	{
		if (okSetStreamParam(hStream, STREAM_RESOLUTION, -1) == -1)
		{
			GetDlgItem(IDC_COMBO1)->EnableWindow(FALSE);
		}
		if (okSetStreamParam(hStream, STREAM_BITRATEMODE, -1) == -1)
		{
			GetDlgItem(IDC_BITRATEMODE)->EnableWindow(FALSE);
		}
		if (okSetStreamParam(hStream, STREAM_MAXBITRATE, -1) == -1)
		{
			GetDlgItem(IDC_MAXBITRATE)->EnableWindow(FALSE);
		}
		if (okSetStreamParam(hStream, STREAM_PICKFRMRATE, -1) == -1)
		{
			GetDlgItem(IDC_PICFRMRATE)->EnableWindow(FALSE);
		}
		if (okSetStreamParam(hStream, STREAM_QUALITY, -1) == -1)
		{
			GetDlgItem(IDC_QUALITY)->EnableWindow(FALSE);
		}
		node=okGetTypeCode(hBoard,NULL);
		if ((node==OK_C20B)||(node==OK_C21B)||(node==OK_C21B_E))
		{
			strcpy(szFileName,"test.m2v");

			CComboBox* m_combo=(CComboBox *)GetDlgItem(IDC_COMBO1);
			int resolution = okSetStreamParam(hStream, STREAM_RESOLUTION, -1);
			if (resolution==3)
				m_combo->SetCurSel(0);	
			else if(resolution==2)
				m_combo->SetCurSel(1);
			else if(resolution==1)
				m_combo->SetCurSel(2);
			else 
				m_combo->SetCurSel(3);

			m_bitrate = okSetStreamParam(hStream, STREAM_BITRATEMODE, -1); 
			m_maxbitrate = okSetStreamParam(hStream, STREAM_MAXBITRATE, -1);
			UpdateData(FALSE);			
		}
		else if((node==OK_RGB60C)||(node==OK_RGB60B)||(node==OK_RGB61C_E)||(node==OK_RGB61C_X)||(node==OK_RGB61C_4E))
		{
			strcpy(szFileName,"test.avi,mjpg");

			m_picfrmrate = okSetStreamParam(hStream,STREAM_PICKFRMRATE,-1);
			m_quality = okSetStreamParam(hStream,STREAM_QUALITY,-1);
			UpdateData(FALSE);
		}
		else
		{
			MessageBox("򿪷ʱûеĿͣ","WORNING",MB_OK);
			GetDlgItem(IDC_PICFRMRATE)->EnableWindow(false);
			GetDlgItem(IDC_QUALITY)->EnableWindow(false);
			GetDlgItem(IDC_BITRATEMODE)->EnableWindow(false);
			GetDlgItem(IDC_MAXBITRATE)->EnableWindow(false);
			GetDlgItem(IDC_COMBO1)->EnableWindow(false);
		}
	}
	else
	{
		MessageBox("ÿûӲѹܣ","WORNING",MB_OK);
		GetDlgItem(IDC_PICFRMRATE)->EnableWindow(false);
		GetDlgItem(IDC_QUALITY)->EnableWindow(false);
		GetDlgItem(IDC_BITRATEMODE)->EnableWindow(false);
		GetDlgItem(IDC_MAXBITRATE)->EnableWindow(false);
		GetDlgItem(IDC_COMBO1)->EnableWindow(false);
	}
//	okSetCaptureParam(hBoard,CAPTURE_CLIPMODE,0);
//	okSetCaptureParam(hBoard,CAPTURE_BUFRGBFORMAT,FORM_RGB888);
	RECT	bufrect;
	bufrect.right = -1;
	okSetTargetRect(hBoard, BUFFER, &bufrect);//õǰͼֱ	
	lpbi=(LPBITMAPINFOHEADER)GlobalAlloc(GPTR,bufrect.right*bufrect.bottom*4+5120);
	lpdib=(LPBYTE)lpbi+5120;
	hWnd=AfxGetApp()->m_pMainWnd->m_hWnd;

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSavebyhardwareDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSavebyhardwareDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDC *cdc;
		RECT rect;
		
		cdc=m_image.GetDC();
		
		m_image.GetClientRect(&rect);
		SetStretchBltMode(cdc->m_hDC,STRETCH_DELETESCANS);
		StretchDIBits(cdc->m_hDC,
			rect.left,rect.top,
			rect.right,rect.bottom, 
			0,0, //horzstart, vertstart, 
			lpbi->biWidth,lpbi->biHeight,
			lpdib,(LPBITMAPINFO)lpbi, 
			DIB_RGB_COLORS,SRCCOPY);
		
 		ReleaseDC(cdc);
		CDialog::OnPaint();
	}
}

BOOL CALLBACK exMsgCallback(HANDLE hStream, LPBYTE lpStreamBuf, long length)
{
	char str[100];
	int currtime;
	static long TotalLength;

	currtime=okGetTickCount()-elapsed;
	TotalLength+=length;
 	if (currtime)
 	{
		if ((node==OK_C20B)||(node==OK_C21B)||(node==OK_C21B_E))
		{
			sprintf(str,"MPEG2 Captured Times= %d Seconds,Section = %d,Rate = %d (KB/S)",(okGetTickCount()-starttime)/1000,length,TotalLength/(okGetTickCount()-elapsed));
			SetWindowText(hWnd,str);
			elapsed=okGetTickCount();
			TotalLength=0;
		}
		else if((node==OK_RGB60C)||(node==OK_RGB60B)||(node==OK_RGB61C_E)||(node==OK_RGB61C_X)||(node==OK_RGB61C_4E))
		{
			sprintf(str,"MJPG Captured Times= %d Seconds,Section = %d,Rate = %d (KB/S)  ",
				(okGetTickCount()-starttime)/1000,length,
				TotalLength/(okGetTickCount()-elapsed));
			SetWindowText(hWnd,str);
			elapsed=okGetTickCount();
			TotalLength=0;
		}
	}
	
	return 1;
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSavebyhardwareDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSavebyhardwareDlg::OnCapture() 
{
	int     i;
	
	okSetSeqCallback(hBoard,BeginCapture,Process,EndCapture);
// 	okCaptureSequence(hBoard,0,-1);//жϷʽ
	okCaptureTo(hBoard,BUFFER,0,-1);
 	if(hStream&&(!streamcap))
	{		
		if ((node==OK_C20B)||(node==OK_C21B)||(node==OK_C21B_E))//C20BѹΧ
		{
			CComboBox* m_combo=(CComboBox *)GetDlgItem(IDC_COMBO1);
			int nselect=m_combo->GetCurSel();

			if (nselect==0)
				i=3;
			else if(nselect==1)
				i=2;
			else if(nselect==2)
				i=1;
			else 
				i=0;
			okSetStreamParam(hStream, STREAM_RESOLUTION, i); //for c20b

			m_bitrate=GetDlgItemInt(IDC_BITRATEMODE,NULL,FALSE);
			if (m_bitrate<0)
			{
				m_bitrate=0;
			}
			else if (m_bitrate>65535)
			{
				m_bitrate=65535;
			}
			okSetStreamParam(hStream, STREAM_BITRATEMODE, m_bitrate); //for c20b

			m_maxbitrate=GetDlgItemInt(IDC_MAXBITRATE,NULL,FALSE);
			if (m_maxbitrate<0)
			{
				m_maxbitrate=0;
			}
			else if (m_maxbitrate>65535)
			{
				m_maxbitrate=65535;
			}

			okSetStreamParam(hStream, STREAM_MAXBITRATE, m_maxbitrate); //for c20b

		} 
		else if((node==OK_RGB60C)||(node==OK_RGB60B)||(node==OK_RGB61C_E)||(node==OK_RGB61C_X)||(node==OK_RGB61C_4E))//mjpgѹӣ֡ʵ
		{
			m_picfrmrate=GetDlgItemInt(IDC_PICFRMRATE,NULL,FALSE);
			if (m_picfrmrate<0)
			{
				m_picfrmrate=0;
			}
			else if (m_picfrmrate>=100)
			{
				m_picfrmrate=100;
			}
			
 		 	okSetStreamParam(hStream,STREAM_PICKFRMRATE,m_picfrmrate);//set rate to pick number of frame per 100 frames, for rgb60c
			m_quality=GetDlgItemInt(IDC_QUALITY,NULL,FALSE);
			if (m_quality<0)
			{
				m_quality=0;
			}
			else if (m_quality>=100)
			{
				m_quality=100;
			}
 		 	okSetStreamParam(hStream,STREAM_QUALITY,m_quality);
		//	okSetStreamParam(hStream, STREAM_RECTSOURCE, 0); //0(default): same as rect of capture, 1:self, independent, for rgb60c
		// 	okSetStreamParam(hStream,STREAM_SOURCERECT,); //set independent rect of stream source (lParam=&rect), for rgb60c
		}
	
	

		if (okCaptureStream(hStream,(TARGET)szFileName,(FARPROC)exMsgCallback,0))//ʼɼѹļлصʽ
		{
			streamcap=1;
		}		
		starttime=elapsed=okGetTickCount();
//		okCaptureStream(hStream,(TARGET)szFileName,NULL,0);//ʼɼѹļ޻صʽ

	}
}

void CSavebyhardwareDlg::OnStop() 
{
	if(hStream&&streamcap)
	{
		int i;
		i=okStopCaptureStream(hStream,0);//ֹͣѹ
		if (i!=0)
		{
			streamcap=0;
		}

	}
	okStopCapture(hBoard);
}

void CAboutDlg::OnClose() 
{
// 	if(hStream)
// 	{
// 		okStopCaptureStream(hStream,0);
// 		okCloseStream(hStream);
// 	}
// 	
// 	okStopCapture(hBoard);
// 	okCloseBoard(hBoard);
// 	GlobalFree(lpbi);

	CDialog::OnClose();
}

BOOL CALLBACK BeginCapture(HANDLE hBoard)
{	
	short		width,height;
	long		form;
	exGetTargetSize(hBoard, BUFFER, &width, &height);
	form=okSetCaptureParam(hBoard,CAPTURE_SCRRGBFORMAT,GETCURRPARAM); //-1
	exSetBitmapHeader(lpbi, width, height, HIWORD(form), LOWORD(form) );
	blk.lpBits=lpdib;
	blk.iBitCount=lpbi->biBitCount;
	blk.iHeight =-(short)lpbi->biHeight;
	blk.iWidth =(short)lpbi->biWidth;
	
	return 1;
} 

BOOL CALLBACK Process(HANDLE hBoard,long no)
{	
	okConvertRect(hBoard,(TARGET)&blk,0,BUFFER,no,1);
	InvalidateRect(hWnd,NULL,FALSE);
	UpdateWindow(hWnd);
	
	return 1;
}


BOOL CALLBACK EndCapture(HANDLE hBoard)
{
	okSetSeqCallback(hBoard,NULL,NULL,NULL);
// 	okStopCapture(hBoard);
	
	return 1;
}
//********************************************************************

long exGetTargetSize(HANDLE hBoard, TARGET tgt, short *width, short *height)
{
	RECT	rect;
	long	form;


	if( (tgt==SCREEN ) ||(tgt==BUFFER) ) {
		rect.right=-1;
		okSetTargetRect(hBoard,tgt,&rect); //get current rect
		if(width)
			*width=(short)(rect.right-rect.left);
		if(height)
			*height=(short)(rect.bottom-rect.top);

		if(tgt==SCREEN ) {
			form=okSetCaptureParam(hBoard,CAPTURE_SCRRGBFORMAT,GETCURRPARAM); //-1
			//limit to video rect
			rect.right=-1; //max. captured rect
			okSetTargetRect(hBoard,VIDEO,&rect); //get video rect
			if(width)
				*width=(short)min(*width,rect.right-rect.left);
			if(height)
				*height=(short)min(*height,rect.bottom-rect.top);
		}
		else if(tgt==BUFFER) 
			form=okSetCaptureParam(hBoard,CAPTURE_BUFRGBFORMAT,GETCURRPARAM); //-1

	} else if(tgt>BUFFER) { //from blkinfo
		LPBLOCKINFO	lpblk;
		lpblk=(LPBLOCKINFO)tgt;

		if(width)
			*width=lpblk->iWidth;
		if(height)
			*height=abs(lpblk->iHeight);
		form=MAKELONG(lpblk->iFormType,lpblk->iBitCount);
	}


	return form;
}

long exSetBitmapHeader(LPBITMAPINFOHEADER lpbi,short width,short height, short bits, short form)
{
	long	wbytes;

	if(!lpbi)
		return FALSE;

	
	if(form==FORM_RGB555)
		bits=16;
	wbytes=((((width*bits)+31)&~31)>>3);//bmp need 4 byte align

	lpbi->biWidth=width;
	lpbi->biHeight=height;

	lpbi->biSize=sizeof(BITMAPINFOHEADER);
	lpbi->biPlanes=1;

	lpbi->biBitCount=bits;
	lpbi->biSizeImage=wbytes*height;


	lpbi->biClrUsed=0;
	//special format for 555,565 & 32 
	if(form==FORM_RGB555 || form==FORM_RGB565 || form==FORM_RGB8888 ) 
		lpbi->biCompression=BI_BITFIELDS;
	else
		lpbi->biCompression=0;
	if(lpbi->biCompression==BI_BITFIELDS ) {//
		DWORD	*lpmask;
		lpmask=(DWORD *)((LPSTR)lpbi+lpbi->biSize);

		if(form==FORM_RGB555) {
			lpmask[2]=0x001f; //blue
			lpmask[1]=0x03e0;
			lpmask[0]=0x7c00;
		}
		else if(form==FORM_RGB565) {
			lpmask[2]=0x001f; //blue
			lpmask[1]=0x07e0;
			lpmask[0]=0xf800;
		}
		else if(bits==32 ) {
			lpmask[2]=0x0000ff;
			lpmask[1]=0x00ff00;
			lpmask[0]=0xff0000;
		}
	}
	else if(bits<=14) { // 8,10,12
		int		i,ratio;
		RGBQUAD	*lpRGB=(RGBQUAD *)((LPSTR)lpbi+lpbi->biSize);

		lpbi->biClrUsed=(1<<bits);
		ratio=lpbi->biClrUsed/256;

		for(i=0; i<(short)lpbi->biClrUsed;i++) {
			lpRGB[i].rgbBlue=i/ratio;
			lpRGB[i].rgbGreen=i/ratio;
			lpRGB[i].rgbRed=i/ratio;
			lpRGB[i].rgbReserved=0;
		}
	
	} 
	lpbi->biClrImportant=lpbi->biClrUsed;

	return lpbi->biClrUsed;
}

void CSavebyhardwareDlg::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	if(hStream)
	{
		okStopCaptureStream(hStream,0);
		okCloseStream(hStream);
	}
	okStopCapture(hBoard);
	okCloseBoard(hBoard);
	GlobalFree(lpbi);

	CDialog::OnClose();
}
